***

# i18n

I18n class. Manage translations



* Full name: `\App\Helper\i18n`
* Parent class: [`\Lime\Helper`](../../Lime/Helper.md)



## Properties


### locale



```php
public string $locale
```






***

### _languages



```php
private array $_languages
```






***

### locales



```php
public static array $locales
```



* This property is **static**.


***

### countries



```php
public static array $countries
```



* This property is **static**.


***

### currencies



```php
public static array $currencies
```



* This property is **static**.


***

## Methods


### initialize



```php
protected initialize(): mixed
```











***

### get

Get translated string by key

```php
public get(string $key, string $alternative = null, ?string $lang = null): string
```








**Parameters:**

| Parameter | Type | Description |
|-----------|------|-------------|
| `$key` | **string** | translation key |
| `$alternative` | **string** | returns if $key doesn&#039;t exist |
| `$lang` | **?string** |  |




***

### getstr

Get translated string by key and params

```php
public getstr(string $key, array $params = [], array $alternative = null, ?string $lang = null): string
```








**Parameters:**

| Parameter | Type | Description |
|-----------|------|-------------|
| `$key` | **string** | translation key |
| `$params` | **array** |  |
| `$alternative` | **array** | returns if $key doesn&#039;&#039;t exist |
| `$lang` | **?string** |  |




***

### load

Load language files

```php
public load(string $langfile, string $lang = null): bool
```








**Parameters:**

| Parameter | Type | Description |
|-----------|------|-------------|
| `$langfile` | **string** | path to language file |
| `$lang` | **string** | language to merge to |




***

### data

Get language data

```php
public data(string $lang = null): array
```








**Parameters:**

| Parameter | Type | Description |
|-----------|------|-------------|
| `$lang` | **string** | language |




***


## Inherited methods


### __construct



```php
public __construct(\Lime\App $app, mixed $context = null): mixed
```








**Parameters:**

| Parameter | Type | Description |
|-----------|------|-------------|
| `$app` | **\Lime\App** |  |
| `$context` | **mixed** |  |




***

### initialize



```php
protected initialize(): mixed
```











***

### __call



```php
public __call(mixed $name, mixed $arguments): mixed
```








**Parameters:**

| Parameter | Type | Description |
|-----------|------|-------------|
| `$name` | **mixed** |  |
| `$arguments` | **mixed** |  |




***

### __invoke



```php
public __invoke(mixed $helper): mixed
```








**Parameters:**

| Parameter | Type | Description |
|-----------|------|-------------|
| `$helper` | **mixed** |  |




***

### __get



```php
public __get(mixed $name): mixed
```








**Parameters:**

| Parameter | Type | Description |
|-----------|------|-------------|
| `$name` | **mixed** |  |




***


***

