***

# GdAdapter

Base adapter implementation to handle image manipulation.



* Full name: `\ColorThief\Image\Adapter\GdAdapter`
* Parent class: [`\ColorThief\Image\Adapter\AbstractAdapter`](./AbstractAdapter.md)




## Methods


### isAvailable



```php
public static isAvailable(): bool
```



* This method is **static**.







***

### load

Loads an image resource.

```php
public load(mixed $resource): \ColorThief\Image\Adapter\AdapterInterface
```








**Parameters:**

| Parameter | Type | Description |
|-----------|------|-------------|
| `$resource` | **mixed** |  |




***

### loadFromBinary



```php
public loadFromBinary(string $data): \ColorThief\Image\Adapter\AdapterInterface
```








**Parameters:**

| Parameter | Type | Description |
|-----------|------|-------------|
| `$data` | **string** |  |




***

### loadFromPath



```php
public loadFromPath(string $file): \ColorThief\Image\Adapter\AdapterInterface
```








**Parameters:**

| Parameter | Type | Description |
|-----------|------|-------------|
| `$file` | **string** |  |




***

### destroy

Destroys the image.

```php
public destroy(): void
```











***

### getHeight



```php
public getHeight(): int
```











***

### getWidth



```php
public getWidth(): int
```











***

### getPixelColor



```php
public getPixelColor(int $x, int $y): \stdClass
```








**Parameters:**

| Parameter | Type | Description |
|-----------|------|-------------|
| `$x` | **int** |  |
| `$y` | **int** |  |




***


## Inherited methods


### __construct

Creates new instance of the image adapter.

```php
public __construct(): mixed
```











***

### load

Loads an image resource.

```php
public load(mixed $resource): \ColorThief\Image\Adapter\AdapterInterface
```








**Parameters:**

| Parameter | Type | Description |
|-----------|------|-------------|
| `$resource` | **mixed** |  |




***

### loadFromUrl

Loads an image from given URL.

```php
public loadFromUrl(string $url): \ColorThief\Image\Adapter\AdapterInterface
```








**Parameters:**

| Parameter | Type | Description |
|-----------|------|-------------|
| `$url` | **string** |  |




***

### destroy

Destroys the image.

```php
public destroy(): void
```











***

### getResource

Get the raw resource.

```php
public getResource(): resource|object|null
```











***


***

