***

# I18n

I18n class. Manage translations



* Full name: `\LimeExtra\Helper\I18n`
* Parent class: [`\Lime\Helper`](../../Lime/Helper.md)



## Properties


### locale



```php
public $locale
```






***

### _languages



```php
private $_languages
```






***

### locals



```php
public static $locals
```



* This property is **static**.


***

### countries



```php
public static $countries
```



* This property is **static**.


***

### currencies



```php
public static $currencies
```



* This property is **static**.


***

## Methods


### initialize



```php
public initialize(): mixed
```











***

### get

Get translated string by key

```php
public get(string $key, array $alternative = null, mixed $lang = null): string
```








**Parameters:**

| Parameter | Type | Description |
|-----------|------|-------------|
| `$key` | **string** | translation key |
| `$alternative` | **array** | returns if $key doesn&#039;&#039;t exist |
| `$lang` | **mixed** |  |




***

### getstr

Get translated string by key and params

```php
public getstr(string $key, array $params = [], array $alternative = null, mixed $lang = null): string
```








**Parameters:**

| Parameter | Type | Description |
|-----------|------|-------------|
| `$key` | **string** | translation key |
| `$params` | **array** |  |
| `$alternative` | **array** | returns if $key doesn&#039;&#039;t exist |
| `$lang` | **mixed** |  |




***

### load

Load language files

```php
public load(string $langfile, string $lang = null): bool
```








**Parameters:**

| Parameter | Type | Description |
|-----------|------|-------------|
| `$langfile` | **string** | path to language file |
| `$lang` | **string** | language to merge to |




***

### data

Get language data

```php
public data(string $lang = null): array
```








**Parameters:**

| Parameter | Type | Description |
|-----------|------|-------------|
| `$lang` | **string** | language |




***


## Inherited methods


### __construct



```php
public __construct(mixed $app): mixed
```








**Parameters:**

| Parameter | Type | Description |
|-----------|------|-------------|
| `$app` | **mixed** |  |




***

### initialize



```php
public initialize(): mixed
```











***

### __call



```php
public __call(mixed $name, mixed $arguments): mixed
```








**Parameters:**

| Parameter | Type | Description |
|-----------|------|-------------|
| `$name` | **mixed** |  |
| `$arguments` | **mixed** |  |




***

### __invoke



```php
public __invoke(mixed $helper): mixed
```








**Parameters:**

| Parameter | Type | Description |
|-----------|------|-------------|
| `$helper` | **mixed** |  |




***

### __get



```php
public __get(mixed $name): mixed
```








**Parameters:**

| Parameter | Type | Description |
|-----------|------|-------------|
| `$name` | **mixed** |  |




***


***

