***

# UnsupportedException





* Full name: `\MongoDB\Exception\UnsupportedException`
* Parent class: [`\MongoDB\Exception\RuntimeException`](./RuntimeException.md)




## Methods


### allowDiskUseNotSupported

Thrown when a command's allowDiskUse option is not supported by a server.

```php
public static allowDiskUseNotSupported(): self
```



* This method is **static**.







***

### arrayFiltersNotSupported

Thrown when array filters are not supported by a server.

```php
public static arrayFiltersNotSupported(): self
```



* This method is **static**.


* **Warning:** this method is **deprecated**. This means that this method will likely be removed in a future version.






***

### collationNotSupported

Thrown when collations are not supported by a server.

```php
public static collationNotSupported(): self
```



* This method is **static**.


* **Warning:** this method is **deprecated**. This means that this method will likely be removed in a future version.






***

### commitQuorumNotSupported

Thrown when the commitQuorum option for createIndexes is not supported
by a server.

```php
public static commitQuorumNotSupported(): self
```



* This method is **static**.







***

### explainNotSupported

Thrown when explain is not supported by a server.

```php
public static explainNotSupported(): self
```



* This method is **static**.







***

### hintNotSupported

Thrown when a command's hint option is not supported by a server.

```php
public static hintNotSupported(): self
```



* This method is **static**.







***

### readConcernNotSupported

Thrown when a command's readConcern option is not supported by a server.

```php
public static readConcernNotSupported(): self
```



* This method is **static**.







***

### readConcernNotSupportedInTransaction

Thrown when a readConcern is used with a read operation in a transaction.

```php
public static readConcernNotSupportedInTransaction(): self
```



* This method is **static**.







***

### writeConcernNotSupported

Thrown when a command's writeConcern option is not supported by a server.

```php
public static writeConcernNotSupported(): self
```



* This method is **static**.







***

### writeConcernNotSupportedInTransaction

Thrown when a writeConcern is used with a write operation in a transaction.

```php
public static writeConcernNotSupportedInTransaction(): self
```



* This method is **static**.







***


***

