***

# MimeType





* Full name: `\GuzzleHttp\Psr7\MimeType`
* This class is marked as **final** and can't be subclassed
* This class is a **Final class**


## Constants

| Constant | Visibility | Type | Value |
|:---------|:-----------|:-----|:------|
|`MIME_TYPES`|private| |[&#039;1km&#039; =&gt; &#039;application/vnd.1000minds.decision-model+xml&#039;, &#039;3dml&#039; =&gt; &#039;text/vnd.in3d.3dml&#039;, &#039;3ds&#039; =&gt; &#039;image/x-3ds&#039;, &#039;3g2&#039; =&gt; &#039;video/3gpp2&#039;, &#039;3gp&#039; =&gt; &#039;video/3gp&#039;, &#039;3gpp&#039; =&gt; &#039;video/3gpp&#039;, &#039;3mf&#039; =&gt; &#039;model/3mf&#039;, &#039;7z&#039; =&gt; &#039;application/x-7z-compressed&#039;, &#039;7zip&#039; =&gt; &#039;application/x-7z-compressed&#039;, &#039;123&#039; =&gt; &#039;application/vnd.lotus-1-2-3&#039;, &#039;aab&#039; =&gt; &#039;application/x-authorware-bin&#039;, &#039;aac&#039; =&gt; &#039;audio/x-acc&#039;, &#039;aam&#039; =&gt; &#039;application/x-authorware-map&#039;, &#039;aas&#039; =&gt; &#039;application/x-authorware-seg&#039;, &#039;abw&#039; =&gt; &#039;application/x-abiword&#039;, &#039;ac&#039; =&gt; &#039;application/vnd.nokia.n-gage.ac+xml&#039;, &#039;ac3&#039; =&gt; &#039;audio/ac3&#039;, &#039;acc&#039; =&gt; &#039;application/vnd.americandynamics.acc&#039;, &#039;ace&#039; =&gt; &#039;application/x-ace-compressed&#039;, &#039;acu&#039; =&gt; &#039;application/vnd.acucobol&#039;, &#039;acutc&#039; =&gt; &#039;application/vnd.acucorp&#039;, &#039;adp&#039; =&gt; &#039;audio/adpcm&#039;, &#039;aep&#039; =&gt; &#039;application/vnd.audiograph&#039;, &#039;afm&#039; =&gt; &#039;application/x-font-type1&#039;, &#039;afp&#039; =&gt; &#039;application/vnd.ibm.modcap&#039;, &#039;age&#039; =&gt; &#039;application/vnd.age&#039;, &#039;ahead&#039; =&gt; &#039;application/vnd.ahead.space&#039;, &#039;ai&#039; =&gt; &#039;application/pdf&#039;, &#039;aif&#039; =&gt; &#039;audio/x-aiff&#039;, &#039;aifc&#039; =&gt; &#039;audio/x-aiff&#039;, &#039;aiff&#039; =&gt; &#039;audio/x-aiff&#039;, &#039;air&#039; =&gt; &#039;application/vnd.adobe.air-application-installer-package+zip&#039;, &#039;ait&#039; =&gt; &#039;application/vnd.dvb.ait&#039;, &#039;ami&#039; =&gt; &#039;application/vnd.amiga.ami&#039;, &#039;amr&#039; =&gt; &#039;audio/amr&#039;, &#039;apk&#039; =&gt; &#039;application/vnd.android.package-archive&#039;, &#039;apng&#039; =&gt; &#039;image/apng&#039;, &#039;appcache&#039; =&gt; &#039;text/cache-manifest&#039;, &#039;application&#039; =&gt; &#039;application/x-ms-application&#039;, &#039;apr&#039; =&gt; &#039;application/vnd.lotus-approach&#039;, &#039;arc&#039; =&gt; &#039;application/x-freearc&#039;, &#039;arj&#039; =&gt; &#039;application/x-arj&#039;, &#039;asc&#039; =&gt; &#039;application/pgp-signature&#039;, &#039;asf&#039; =&gt; &#039;video/x-ms-asf&#039;, &#039;asm&#039; =&gt; &#039;text/x-asm&#039;, &#039;aso&#039; =&gt; &#039;application/vnd.accpac.simply.aso&#039;, &#039;asx&#039; =&gt; &#039;video/x-ms-asf&#039;, &#039;atc&#039; =&gt; &#039;application/vnd.acucorp&#039;, &#039;atom&#039; =&gt; &#039;application/atom+xml&#039;, &#039;atomcat&#039; =&gt; &#039;application/atomcat+xml&#039;, &#039;atomdeleted&#039; =&gt; &#039;application/atomdeleted+xml&#039;, &#039;atomsvc&#039; =&gt; &#039;application/atomsvc+xml&#039;, &#039;atx&#039; =&gt; &#039;application/vnd.antix.game-component&#039;, &#039;au&#039; =&gt; &#039;audio/x-au&#039;, &#039;avci&#039; =&gt; &#039;image/avci&#039;, &#039;avcs&#039; =&gt; &#039;image/avcs&#039;, &#039;avi&#039; =&gt; &#039;video/x-msvideo&#039;, &#039;avif&#039; =&gt; &#039;image/avif&#039;, &#039;aw&#039; =&gt; &#039;application/applixware&#039;, &#039;azf&#039; =&gt; &#039;application/vnd.airzip.filesecure.azf&#039;, &#039;azs&#039; =&gt; &#039;application/vnd.airzip.filesecure.azs&#039;, &#039;azv&#039; =&gt; &#039;image/vnd.airzip.accelerator.azv&#039;, &#039;azw&#039; =&gt; &#039;application/vnd.amazon.ebook&#039;, &#039;b16&#039; =&gt; &#039;image/vnd.pco.b16&#039;, &#039;bat&#039; =&gt; &#039;application/x-msdownload&#039;, &#039;bcpio&#039; =&gt; &#039;application/x-bcpio&#039;, &#039;bdf&#039; =&gt; &#039;application/x-font-bdf&#039;, &#039;bdm&#039; =&gt; &#039;application/vnd.syncml.dm+wbxml&#039;, &#039;bdoc&#039; =&gt; &#039;application/x-bdoc&#039;, &#039;bed&#039; =&gt; &#039;application/vnd.realvnc.bed&#039;, &#039;bh2&#039; =&gt; &#039;application/vnd.fujitsu.oasysprs&#039;, &#039;bin&#039; =&gt; &#039;application/octet-stream&#039;, &#039;blb&#039; =&gt; &#039;application/x-blorb&#039;, &#039;blorb&#039; =&gt; &#039;application/x-blorb&#039;, &#039;bmi&#039; =&gt; &#039;application/vnd.bmi&#039;, &#039;bmml&#039; =&gt; &#039;application/vnd.balsamiq.bmml+xml&#039;, &#039;bmp&#039; =&gt; &#039;image/bmp&#039;, &#039;book&#039; =&gt; &#039;application/vnd.framemaker&#039;, &#039;box&#039; =&gt; &#039;application/vnd.previewsystems.box&#039;, &#039;boz&#039; =&gt; &#039;application/x-bzip2&#039;, &#039;bpk&#039; =&gt; &#039;application/octet-stream&#039;, &#039;bpmn&#039; =&gt; &#039;application/octet-stream&#039;, &#039;bsp&#039; =&gt; &#039;model/vnd.valve.source.compiled-map&#039;, &#039;btif&#039; =&gt; &#039;image/prs.btif&#039;, &#039;buffer&#039; =&gt; &#039;application/octet-stream&#039;, &#039;bz&#039; =&gt; &#039;application/x-bzip&#039;, &#039;bz2&#039; =&gt; &#039;application/x-bzip2&#039;, &#039;c&#039; =&gt; &#039;text/x-c&#039;, &#039;c4d&#039; =&gt; &#039;application/vnd.clonk.c4group&#039;, &#039;c4f&#039; =&gt; &#039;application/vnd.clonk.c4group&#039;, &#039;c4g&#039; =&gt; &#039;application/vnd.clonk.c4group&#039;, &#039;c4p&#039; =&gt; &#039;application/vnd.clonk.c4group&#039;, &#039;c4u&#039; =&gt; &#039;application/vnd.clonk.c4group&#039;, &#039;c11amc&#039; =&gt; &#039;application/vnd.cluetrust.cartomobile-config&#039;, &#039;c11amz&#039; =&gt; &#039;application/vnd.cluetrust.cartomobile-config-pkg&#039;, &#039;cab&#039; =&gt; &#039;application/vnd.ms-cab-compressed&#039;, &#039;caf&#039; =&gt; &#039;audio/x-caf&#039;, &#039;cap&#039; =&gt; &#039;application/vnd.tcpdump.pcap&#039;, &#039;car&#039; =&gt; &#039;application/vnd.curl.car&#039;, &#039;cat&#039; =&gt; &#039;application/vnd.ms-pki.seccat&#039;, &#039;cb7&#039; =&gt; &#039;application/x-cbr&#039;, &#039;cba&#039; =&gt; &#039;application/x-cbr&#039;, &#039;cbr&#039; =&gt; &#039;application/x-cbr&#039;, &#039;cbt&#039; =&gt; &#039;application/x-cbr&#039;, &#039;cbz&#039; =&gt; &#039;application/x-cbr&#039;, &#039;cc&#039; =&gt; &#039;text/x-c&#039;, &#039;cco&#039; =&gt; &#039;application/x-cocoa&#039;, &#039;cct&#039; =&gt; &#039;application/x-director&#039;, &#039;ccxml&#039; =&gt; &#039;application/ccxml+xml&#039;, &#039;cdbcmsg&#039; =&gt; &#039;application/vnd.contact.cmsg&#039;, &#039;cdf&#039; =&gt; &#039;application/x-netcdf&#039;, &#039;cdfx&#039; =&gt; &#039;application/cdfx+xml&#039;, &#039;cdkey&#039; =&gt; &#039;application/vnd.mediastation.cdkey&#039;, &#039;cdmia&#039; =&gt; &#039;application/cdmi-capability&#039;, &#039;cdmic&#039; =&gt; &#039;application/cdmi-container&#039;, &#039;cdmid&#039; =&gt; &#039;application/cdmi-domain&#039;, &#039;cdmio&#039; =&gt; &#039;application/cdmi-object&#039;, &#039;cdmiq&#039; =&gt; &#039;application/cdmi-queue&#039;, &#039;cdr&#039; =&gt; &#039;application/cdr&#039;, &#039;cdx&#039; =&gt; &#039;chemical/x-cdx&#039;, &#039;cdxml&#039; =&gt; &#039;application/vnd.chemdraw+xml&#039;, &#039;cdy&#039; =&gt; &#039;application/vnd.cinderella&#039;, &#039;cer&#039; =&gt; &#039;application/pkix-cert&#039;, &#039;cfs&#039; =&gt; &#039;application/x-cfs-compressed&#039;, &#039;cgm&#039; =&gt; &#039;image/cgm&#039;, &#039;chat&#039; =&gt; &#039;application/x-chat&#039;, &#039;chm&#039; =&gt; &#039;application/vnd.ms-htmlhelp&#039;, &#039;chrt&#039; =&gt; &#039;application/vnd.kde.kchart&#039;, &#039;cif&#039; =&gt; &#039;chemical/x-cif&#039;, &#039;cii&#039; =&gt; &#039;application/vnd.anser-web-certificate-issue-initiation&#039;, &#039;cil&#039; =&gt; &#039;application/vnd.ms-artgalry&#039;, &#039;cjs&#039; =&gt; &#039;application/node&#039;, &#039;cla&#039; =&gt; &#039;application/vnd.claymore&#039;, &#039;class&#039; =&gt; &#039;application/octet-stream&#039;, &#039;clkk&#039; =&gt; &#039;application/vnd.crick.clicker.keyboard&#039;, &#039;clkp&#039; =&gt; &#039;application/vnd.crick.clicker.palette&#039;, &#039;clkt&#039; =&gt; &#039;application/vnd.crick.clicker.template&#039;, &#039;clkw&#039; =&gt; &#039;application/vnd.crick.clicker.wordbank&#039;, &#039;clkx&#039; =&gt; &#039;application/vnd.crick.clicker&#039;, &#039;clp&#039; =&gt; &#039;application/x-msclip&#039;, &#039;cmc&#039; =&gt; &#039;application/vnd.cosmocaller&#039;, &#039;cmdf&#039; =&gt; &#039;chemical/x-cmdf&#039;, &#039;cml&#039; =&gt; &#039;chemical/x-cml&#039;, &#039;cmp&#039; =&gt; &#039;application/vnd.yellowriver-custom-menu&#039;, &#039;cmx&#039; =&gt; &#039;image/x-cmx&#039;, &#039;cod&#039; =&gt; &#039;application/vnd.rim.cod&#039;, &#039;coffee&#039; =&gt; &#039;text/coffeescript&#039;, &#039;com&#039; =&gt; &#039;application/x-msdownload&#039;, &#039;conf&#039; =&gt; &#039;text/plain&#039;, &#039;cpio&#039; =&gt; &#039;application/x-cpio&#039;, &#039;cpl&#039; =&gt; &#039;application/cpl+xml&#039;, &#039;cpp&#039; =&gt; &#039;text/x-c&#039;, &#039;cpt&#039; =&gt; &#039;application/mac-compactpro&#039;, &#039;crd&#039; =&gt; &#039;application/x-mscardfile&#039;, &#039;crl&#039; =&gt; &#039;application/pkix-crl&#039;, &#039;crt&#039; =&gt; &#039;application/x-x509-ca-cert&#039;, &#039;crx&#039; =&gt; &#039;application/x-chrome-extension&#039;, &#039;cryptonote&#039; =&gt; &#039;application/vnd.rig.cryptonote&#039;, &#039;csh&#039; =&gt; &#039;application/x-csh&#039;, &#039;csl&#039; =&gt; &#039;application/vnd.citationstyles.style+xml&#039;, &#039;csml&#039; =&gt; &#039;chemical/x-csml&#039;, &#039;csp&#039; =&gt; &#039;application/vnd.commonspace&#039;, &#039;csr&#039; =&gt; &#039;application/octet-stream&#039;, &#039;css&#039; =&gt; &#039;text/css&#039;, &#039;cst&#039; =&gt; &#039;application/x-director&#039;, &#039;csv&#039; =&gt; &#039;text/csv&#039;, &#039;cu&#039; =&gt; &#039;application/cu-seeme&#039;, &#039;curl&#039; =&gt; &#039;text/vnd.curl&#039;, &#039;cww&#039; =&gt; &#039;application/prs.cww&#039;, &#039;cxt&#039; =&gt; &#039;application/x-director&#039;, &#039;cxx&#039; =&gt; &#039;text/x-c&#039;, &#039;dae&#039; =&gt; &#039;model/vnd.collada+xml&#039;, &#039;daf&#039; =&gt; &#039;application/vnd.mobius.daf&#039;, &#039;dart&#039; =&gt; &#039;application/vnd.dart&#039;, &#039;dataless&#039; =&gt; &#039;application/vnd.fdsn.seed&#039;, &#039;davmount&#039; =&gt; &#039;application/davmount+xml&#039;, &#039;dbf&#039; =&gt; &#039;application/vnd.dbf&#039;, &#039;dbk&#039; =&gt; &#039;application/docbook+xml&#039;, &#039;dcr&#039; =&gt; &#039;application/x-director&#039;, &#039;dcurl&#039; =&gt; &#039;text/vnd.curl.dcurl&#039;, &#039;dd2&#039; =&gt; &#039;application/vnd.oma.dd2+xml&#039;, &#039;ddd&#039; =&gt; &#039;application/vnd.fujixerox.ddd&#039;, &#039;ddf&#039; =&gt; &#039;application/vnd.syncml.dmddf+xml&#039;, &#039;dds&#039; =&gt; &#039;image/vnd.ms-dds&#039;, &#039;deb&#039; =&gt; &#039;application/x-debian-package&#039;, &#039;def&#039; =&gt; &#039;text/plain&#039;, &#039;deploy&#039; =&gt; &#039;application/octet-stream&#039;, &#039;der&#039; =&gt; &#039;application/x-x509-ca-cert&#039;, &#039;dfac&#039; =&gt; &#039;application/vnd.dreamfactory&#039;, &#039;dgc&#039; =&gt; &#039;application/x-dgc-compressed&#039;, &#039;dic&#039; =&gt; &#039;text/x-c&#039;, &#039;dir&#039; =&gt; &#039;application/x-director&#039;, &#039;dis&#039; =&gt; &#039;application/vnd.mobius.dis&#039;, &#039;disposition-notification&#039; =&gt; &#039;message/disposition-notification&#039;, &#039;dist&#039; =&gt; &#039;application/octet-stream&#039;, &#039;distz&#039; =&gt; &#039;application/octet-stream&#039;, &#039;djv&#039; =&gt; &#039;image/vnd.djvu&#039;, &#039;djvu&#039; =&gt; &#039;image/vnd.djvu&#039;, &#039;dll&#039; =&gt; &#039;application/octet-stream&#039;, &#039;dmg&#039; =&gt; &#039;application/x-apple-diskimage&#039;, &#039;dmn&#039; =&gt; &#039;application/octet-stream&#039;, &#039;dmp&#039; =&gt; &#039;application/vnd.tcpdump.pcap&#039;, &#039;dms&#039; =&gt; &#039;application/octet-stream&#039;, &#039;dna&#039; =&gt; &#039;application/vnd.dna&#039;, &#039;doc&#039; =&gt; &#039;application/msword&#039;, &#039;docm&#039; =&gt; &#039;application/vnd.ms-word.template.macroEnabled.12&#039;, &#039;docx&#039; =&gt; &#039;application/vnd.openxmlformats-officedocument.wordprocessingml.document&#039;, &#039;dot&#039; =&gt; &#039;application/msword&#039;, &#039;dotm&#039; =&gt; &#039;application/vnd.ms-word.template.macroEnabled.12&#039;, &#039;dotx&#039; =&gt; &#039;application/vnd.openxmlformats-officedocument.wordprocessingml.template&#039;, &#039;dp&#039; =&gt; &#039;application/vnd.osgi.dp&#039;, &#039;dpg&#039; =&gt; &#039;application/vnd.dpgraph&#039;, &#039;dra&#039; =&gt; &#039;audio/vnd.dra&#039;, &#039;drle&#039; =&gt; &#039;image/dicom-rle&#039;, &#039;dsc&#039; =&gt; &#039;text/prs.lines.tag&#039;, &#039;dssc&#039; =&gt; &#039;application/dssc+der&#039;, &#039;dtb&#039; =&gt; &#039;application/x-dtbook+xml&#039;, &#039;dtd&#039; =&gt; &#039;application/xml-dtd&#039;, &#039;dts&#039; =&gt; &#039;audio/vnd.dts&#039;, &#039;dtshd&#039; =&gt; &#039;audio/vnd.dts.hd&#039;, &#039;dump&#039; =&gt; &#039;application/octet-stream&#039;, &#039;dvb&#039; =&gt; &#039;video/vnd.dvb.file&#039;, &#039;dvi&#039; =&gt; &#039;application/x-dvi&#039;, &#039;dwd&#039; =&gt; &#039;application/atsc-dwd+xml&#039;, &#039;dwf&#039; =&gt; &#039;model/vnd.dwf&#039;, &#039;dwg&#039; =&gt; &#039;image/vnd.dwg&#039;, &#039;dxf&#039; =&gt; &#039;image/vnd.dxf&#039;, &#039;dxp&#039; =&gt; &#039;application/vnd.spotfire.dxp&#039;, &#039;dxr&#039; =&gt; &#039;application/x-director&#039;, &#039;ear&#039; =&gt; &#039;application/java-archive&#039;, &#039;ecelp4800&#039; =&gt; &#039;audio/vnd.nuera.ecelp4800&#039;, &#039;ecelp7470&#039; =&gt; &#039;audio/vnd.nuera.ecelp7470&#039;, &#039;ecelp9600&#039; =&gt; &#039;audio/vnd.nuera.ecelp9600&#039;, &#039;ecma&#039; =&gt; &#039;application/ecmascript&#039;, &#039;edm&#039; =&gt; &#039;application/vnd.novadigm.edm&#039;, &#039;edx&#039; =&gt; &#039;application/vnd.novadigm.edx&#039;, &#039;efif&#039; =&gt; &#039;application/vnd.picsel&#039;, &#039;ei6&#039; =&gt; &#039;application/vnd.pg.osasli&#039;, &#039;elc&#039; =&gt; &#039;application/octet-stream&#039;, &#039;emf&#039; =&gt; &#039;image/emf&#039;, &#039;eml&#039; =&gt; &#039;message/rfc822&#039;, &#039;emma&#039; =&gt; &#039;application/emma+xml&#039;, &#039;emotionml&#039; =&gt; &#039;application/emotionml+xml&#039;, &#039;emz&#039; =&gt; &#039;application/x-msmetafile&#039;, &#039;eol&#039; =&gt; &#039;audio/vnd.digital-winds&#039;, &#039;eot&#039; =&gt; &#039;application/vnd.ms-fontobject&#039;, &#039;eps&#039; =&gt; &#039;application/postscript&#039;, &#039;epub&#039; =&gt; &#039;application/epub+zip&#039;, &#039;es&#039; =&gt; &#039;application/ecmascript&#039;, &#039;es3&#039; =&gt; &#039;application/vnd.eszigno3+xml&#039;, &#039;esa&#039; =&gt; &#039;application/vnd.osgi.subsystem&#039;, &#039;esf&#039; =&gt; &#039;application/vnd.epson.esf&#039;, &#039;et3&#039; =&gt; &#039;application/vnd.eszigno3+xml&#039;, &#039;etx&#039; =&gt; &#039;text/x-setext&#039;, &#039;eva&#039; =&gt; &#039;application/x-eva&#039;, &#039;evy&#039; =&gt; &#039;application/x-envoy&#039;, &#039;exe&#039; =&gt; &#039;application/octet-stream&#039;, &#039;exi&#039; =&gt; &#039;application/exi&#039;, &#039;exp&#039; =&gt; &#039;application/express&#039;, &#039;exr&#039; =&gt; &#039;image/aces&#039;, &#039;ext&#039; =&gt; &#039;application/vnd.novadigm.ext&#039;, &#039;ez&#039; =&gt; &#039;application/andrew-inset&#039;, &#039;ez2&#039; =&gt; &#039;application/vnd.ezpix-album&#039;, &#039;ez3&#039; =&gt; &#039;application/vnd.ezpix-package&#039;, &#039;f&#039; =&gt; &#039;text/x-fortran&#039;, &#039;f4v&#039; =&gt; &#039;video/mp4&#039;, &#039;f77&#039; =&gt; &#039;text/x-fortran&#039;, &#039;f90&#039; =&gt; &#039;text/x-fortran&#039;, &#039;fbs&#039; =&gt; &#039;image/vnd.fastbidsheet&#039;, &#039;fcdt&#039; =&gt; &#039;application/vnd.adobe.formscentral.fcdt&#039;, &#039;fcs&#039; =&gt; &#039;application/vnd.isac.fcs&#039;, &#039;fdf&#039; =&gt; &#039;application/vnd.fdf&#039;, &#039;fdt&#039; =&gt; &#039;application/fdt+xml&#039;, &#039;fe_launch&#039; =&gt; &#039;application/vnd.denovo.fcselayout-link&#039;, &#039;fg5&#039; =&gt; &#039;application/vnd.fujitsu.oasysgp&#039;, &#039;fgd&#039; =&gt; &#039;application/x-director&#039;, &#039;fh&#039; =&gt; &#039;image/x-freehand&#039;, &#039;fh4&#039; =&gt; &#039;image/x-freehand&#039;, &#039;fh5&#039; =&gt; &#039;image/x-freehand&#039;, &#039;fh7&#039; =&gt; &#039;image/x-freehand&#039;, &#039;fhc&#039; =&gt; &#039;image/x-freehand&#039;, &#039;fig&#039; =&gt; &#039;application/x-xfig&#039;, &#039;fits&#039; =&gt; &#039;image/fits&#039;, &#039;flac&#039; =&gt; &#039;audio/x-flac&#039;, &#039;fli&#039; =&gt; &#039;video/x-fli&#039;, &#039;flo&#039; =&gt; &#039;application/vnd.micrografx.flo&#039;, &#039;flv&#039; =&gt; &#039;video/x-flv&#039;, &#039;flw&#039; =&gt; &#039;application/vnd.kde.kivio&#039;, &#039;flx&#039; =&gt; &#039;text/vnd.fmi.flexstor&#039;, &#039;fly&#039; =&gt; &#039;text/vnd.fly&#039;, &#039;fm&#039; =&gt; &#039;application/vnd.framemaker&#039;, &#039;fnc&#039; =&gt; &#039;application/vnd.frogans.fnc&#039;, &#039;fo&#039; =&gt; &#039;application/vnd.software602.filler.form+xml&#039;, &#039;for&#039; =&gt; &#039;text/x-fortran&#039;, &#039;fpx&#039; =&gt; &#039;image/vnd.fpx&#039;, &#039;frame&#039; =&gt; &#039;application/vnd.framemaker&#039;, &#039;fsc&#039; =&gt; &#039;application/vnd.fsc.weblaunch&#039;, &#039;fst&#039; =&gt; &#039;image/vnd.fst&#039;, &#039;ftc&#039; =&gt; &#039;application/vnd.fluxtime.clip&#039;, &#039;fti&#039; =&gt; &#039;application/vnd.anser-web-funds-transfer-initiation&#039;, &#039;fvt&#039; =&gt; &#039;video/vnd.fvt&#039;, &#039;fxp&#039; =&gt; &#039;application/vnd.adobe.fxp&#039;, &#039;fxpl&#039; =&gt; &#039;application/vnd.adobe.fxp&#039;, &#039;fzs&#039; =&gt; &#039;application/vnd.fuzzysheet&#039;, &#039;g2w&#039; =&gt; &#039;application/vnd.geoplan&#039;, &#039;g3&#039; =&gt; &#039;image/g3fax&#039;, &#039;g3w&#039; =&gt; &#039;application/vnd.geospace&#039;, &#039;gac&#039; =&gt; &#039;application/vnd.groove-account&#039;, &#039;gam&#039; =&gt; &#039;application/x-tads&#039;, &#039;gbr&#039; =&gt; &#039;application/rpki-ghostbusters&#039;, &#039;gca&#039; =&gt; &#039;application/x-gca-compressed&#039;, &#039;gdl&#039; =&gt; &#039;model/vnd.gdl&#039;, &#039;gdoc&#039; =&gt; &#039;application/vnd.google-apps.document&#039;, &#039;ged&#039; =&gt; &#039;text/vnd.familysearch.gedcom&#039;, &#039;geo&#039; =&gt; &#039;application/vnd.dynageo&#039;, &#039;geojson&#039; =&gt; &#039;application/geo+json&#039;, &#039;gex&#039; =&gt; &#039;application/vnd.geometry-explorer&#039;, &#039;ggb&#039; =&gt; &#039;application/vnd.geogebra.file&#039;, &#039;ggt&#039; =&gt; &#039;application/vnd.geogebra.tool&#039;, &#039;ghf&#039; =&gt; &#039;application/vnd.groove-help&#039;, &#039;gif&#039; =&gt; &#039;image/gif&#039;, &#039;gim&#039; =&gt; &#039;application/vnd.groove-identity-message&#039;, &#039;glb&#039; =&gt; &#039;model/gltf-binary&#039;, &#039;gltf&#039; =&gt; &#039;model/gltf+json&#039;, &#039;gml&#039; =&gt; &#039;application/gml+xml&#039;, &#039;gmx&#039; =&gt; &#039;application/vnd.gmx&#039;, &#039;gnumeric&#039; =&gt; &#039;application/x-gnumeric&#039;, &#039;gpg&#039; =&gt; &#039;application/gpg-keys&#039;, &#039;gph&#039; =&gt; &#039;application/vnd.flographit&#039;, &#039;gpx&#039; =&gt; &#039;application/gpx+xml&#039;, &#039;gqf&#039; =&gt; &#039;application/vnd.grafeq&#039;, &#039;gqs&#039; =&gt; &#039;application/vnd.grafeq&#039;, &#039;gram&#039; =&gt; &#039;application/srgs&#039;, &#039;gramps&#039; =&gt; &#039;application/x-gramps-xml&#039;, &#039;gre&#039; =&gt; &#039;application/vnd.geometry-explorer&#039;, &#039;grv&#039; =&gt; &#039;application/vnd.groove-injector&#039;, &#039;grxml&#039; =&gt; &#039;application/srgs+xml&#039;, &#039;gsf&#039; =&gt; &#039;application/x-font-ghostscript&#039;, &#039;gsheet&#039; =&gt; &#039;application/vnd.google-apps.spreadsheet&#039;, &#039;gslides&#039; =&gt; &#039;application/vnd.google-apps.presentation&#039;, &#039;gtar&#039; =&gt; &#039;application/x-gtar&#039;, &#039;gtm&#039; =&gt; &#039;application/vnd.groove-tool-message&#039;, &#039;gtw&#039; =&gt; &#039;model/vnd.gtw&#039;, &#039;gv&#039; =&gt; &#039;text/vnd.graphviz&#039;, &#039;gxf&#039; =&gt; &#039;application/gxf&#039;, &#039;gxt&#039; =&gt; &#039;application/vnd.geonext&#039;, &#039;gz&#039; =&gt; &#039;application/gzip&#039;, &#039;gzip&#039; =&gt; &#039;application/gzip&#039;, &#039;h&#039; =&gt; &#039;text/x-c&#039;, &#039;h261&#039; =&gt; &#039;video/h261&#039;, &#039;h263&#039; =&gt; &#039;video/h263&#039;, &#039;h264&#039; =&gt; &#039;video/h264&#039;, &#039;hal&#039; =&gt; &#039;application/vnd.hal+xml&#039;, &#039;hbci&#039; =&gt; &#039;application/vnd.hbci&#039;, &#039;hbs&#039; =&gt; &#039;text/x-handlebars-template&#039;, &#039;hdd&#039; =&gt; &#039;application/x-virtualbox-hdd&#039;, &#039;hdf&#039; =&gt; &#039;application/x-hdf&#039;, &#039;heic&#039; =&gt; &#039;image/heic&#039;, &#039;heics&#039; =&gt; &#039;image/heic-sequence&#039;, &#039;heif&#039; =&gt; &#039;image/heif&#039;, &#039;heifs&#039; =&gt; &#039;image/heif-sequence&#039;, &#039;hej2&#039; =&gt; &#039;image/hej2k&#039;, &#039;held&#039; =&gt; &#039;application/atsc-held+xml&#039;, &#039;hh&#039; =&gt; &#039;text/x-c&#039;, &#039;hjson&#039; =&gt; &#039;application/hjson&#039;, &#039;hlp&#039; =&gt; &#039;application/winhlp&#039;, &#039;hpgl&#039; =&gt; &#039;application/vnd.hp-hpgl&#039;, &#039;hpid&#039; =&gt; &#039;application/vnd.hp-hpid&#039;, &#039;hps&#039; =&gt; &#039;application/vnd.hp-hps&#039;, &#039;hqx&#039; =&gt; &#039;application/mac-binhex40&#039;, &#039;hsj2&#039; =&gt; &#039;image/hsj2&#039;, &#039;htc&#039; =&gt; &#039;text/x-component&#039;, &#039;htke&#039; =&gt; &#039;application/vnd.kenameaapp&#039;, &#039;htm&#039; =&gt; &#039;text/html&#039;, &#039;html&#039; =&gt; &#039;text/html&#039;, &#039;hvd&#039; =&gt; &#039;application/vnd.yamaha.hv-dic&#039;, &#039;hvp&#039; =&gt; &#039;application/vnd.yamaha.hv-voice&#039;, &#039;hvs&#039; =&gt; &#039;application/vnd.yamaha.hv-script&#039;, &#039;i2g&#039; =&gt; &#039;application/vnd.intergeo&#039;, &#039;icc&#039; =&gt; &#039;application/vnd.iccprofile&#039;, &#039;ice&#039; =&gt; &#039;x-conference/x-cooltalk&#039;, &#039;icm&#039; =&gt; &#039;application/vnd.iccprofile&#039;, &#039;ico&#039; =&gt; &#039;image/x-icon&#039;, &#039;ics&#039; =&gt; &#039;text/calendar&#039;, &#039;ief&#039; =&gt; &#039;image/ief&#039;, &#039;ifb&#039; =&gt; &#039;text/calendar&#039;, &#039;ifm&#039; =&gt; &#039;application/vnd.shana.informed.formdata&#039;, &#039;iges&#039; =&gt; &#039;model/iges&#039;, &#039;igl&#039; =&gt; &#039;application/vnd.igloader&#039;, &#039;igm&#039; =&gt; &#039;application/vnd.insors.igm&#039;, &#039;igs&#039; =&gt; &#039;model/iges&#039;, &#039;igx&#039; =&gt; &#039;application/vnd.micrografx.igx&#039;, &#039;iif&#039; =&gt; &#039;application/vnd.shana.informed.interchange&#039;, &#039;img&#039; =&gt; &#039;application/octet-stream&#039;, &#039;imp&#039; =&gt; &#039;application/vnd.accpac.simply.imp&#039;, &#039;ims&#039; =&gt; &#039;application/vnd.ms-ims&#039;, &#039;in&#039; =&gt; &#039;text/plain&#039;, &#039;ini&#039; =&gt; &#039;text/plain&#039;, &#039;ink&#039; =&gt; &#039;application/inkml+xml&#039;, &#039;inkml&#039; =&gt; &#039;application/inkml+xml&#039;, &#039;install&#039; =&gt; &#039;application/x-install-instructions&#039;, &#039;iota&#039; =&gt; &#039;application/vnd.astraea-software.iota&#039;, &#039;ipfix&#039; =&gt; &#039;application/ipfix&#039;, &#039;ipk&#039; =&gt; &#039;application/vnd.shana.informed.package&#039;, &#039;irm&#039; =&gt; &#039;application/vnd.ibm.rights-management&#039;, &#039;irp&#039; =&gt; &#039;application/vnd.irepository.package+xml&#039;, &#039;iso&#039; =&gt; &#039;application/x-iso9660-image&#039;, &#039;itp&#039; =&gt; &#039;application/vnd.shana.informed.formtemplate&#039;, &#039;its&#039; =&gt; &#039;application/its+xml&#039;, &#039;ivp&#039; =&gt; &#039;application/vnd.immervision-ivp&#039;, &#039;ivu&#039; =&gt; &#039;application/vnd.immervision-ivu&#039;, &#039;jad&#039; =&gt; &#039;text/vnd.sun.j2me.app-descriptor&#039;, &#039;jade&#039; =&gt; &#039;text/jade&#039;, &#039;jam&#039; =&gt; &#039;application/vnd.jam&#039;, &#039;jar&#039; =&gt; &#039;application/java-archive&#039;, &#039;jardiff&#039; =&gt; &#039;application/x-java-archive-diff&#039;, &#039;java&#039; =&gt; &#039;text/x-java-source&#039;, &#039;jhc&#039; =&gt; &#039;image/jphc&#039;, &#039;jisp&#039; =&gt; &#039;application/vnd.jisp&#039;, &#039;jls&#039; =&gt; &#039;image/jls&#039;, &#039;jlt&#039; =&gt; &#039;application/vnd.hp-jlyt&#039;, &#039;jng&#039; =&gt; &#039;image/x-jng&#039;, &#039;jnlp&#039; =&gt; &#039;application/x-java-jnlp-file&#039;, &#039;joda&#039; =&gt; &#039;application/vnd.joost.joda-archive&#039;, &#039;jp2&#039; =&gt; &#039;image/jp2&#039;, &#039;jpe&#039; =&gt; &#039;image/jpeg&#039;, &#039;jpeg&#039; =&gt; &#039;image/jpeg&#039;, &#039;jpf&#039; =&gt; &#039;image/jpx&#039;, &#039;jpg&#039; =&gt; &#039;image/jpeg&#039;, &#039;jpg2&#039; =&gt; &#039;image/jp2&#039;, &#039;jpgm&#039; =&gt; &#039;video/jpm&#039;, &#039;jpgv&#039; =&gt; &#039;video/jpeg&#039;, &#039;jph&#039; =&gt; &#039;image/jph&#039;, &#039;jpm&#039; =&gt; &#039;video/jpm&#039;, &#039;jpx&#039; =&gt; &#039;image/jpx&#039;, &#039;js&#039; =&gt; &#039;application/javascript&#039;, &#039;json&#039; =&gt; &#039;application/json&#039;, &#039;json5&#039; =&gt; &#039;application/json5&#039;, &#039;jsonld&#039; =&gt; &#039;application/ld+json&#039;, &#039;jsonml&#039; =&gt; &#039;application/jsonml+json&#039;, &#039;jsx&#039; =&gt; &#039;text/jsx&#039;, &#039;jxr&#039; =&gt; &#039;image/jxr&#039;, &#039;jxra&#039; =&gt; &#039;image/jxra&#039;, &#039;jxrs&#039; =&gt; &#039;image/jxrs&#039;, &#039;jxs&#039; =&gt; &#039;image/jxs&#039;, &#039;jxsc&#039; =&gt; &#039;image/jxsc&#039;, &#039;jxsi&#039; =&gt; &#039;image/jxsi&#039;, &#039;jxss&#039; =&gt; &#039;image/jxss&#039;, &#039;kar&#039; =&gt; &#039;audio/midi&#039;, &#039;karbon&#039; =&gt; &#039;application/vnd.kde.karbon&#039;, &#039;kdb&#039; =&gt; &#039;application/octet-stream&#039;, &#039;kdbx&#039; =&gt; &#039;application/x-keepass2&#039;, &#039;key&#039; =&gt; &#039;application/x-iwork-keynote-sffkey&#039;, &#039;kfo&#039; =&gt; &#039;application/vnd.kde.kformula&#039;, &#039;kia&#039; =&gt; &#039;application/vnd.kidspiration&#039;, &#039;kml&#039; =&gt; &#039;application/vnd.google-earth.kml+xml&#039;, &#039;kmz&#039; =&gt; &#039;application/vnd.google-earth.kmz&#039;, &#039;kne&#039; =&gt; &#039;application/vnd.kinar&#039;, &#039;knp&#039; =&gt; &#039;application/vnd.kinar&#039;, &#039;kon&#039; =&gt; &#039;application/vnd.kde.kontour&#039;, &#039;kpr&#039; =&gt; &#039;application/vnd.kde.kpresenter&#039;, &#039;kpt&#039; =&gt; &#039;application/vnd.kde.kpresenter&#039;, &#039;kpxx&#039; =&gt; &#039;application/vnd.ds-keypoint&#039;, &#039;ksp&#039; =&gt; &#039;application/vnd.kde.kspread&#039;, &#039;ktr&#039; =&gt; &#039;application/vnd.kahootz&#039;, &#039;ktx&#039; =&gt; &#039;image/ktx&#039;, &#039;ktx2&#039; =&gt; &#039;image/ktx2&#039;, &#039;ktz&#039; =&gt; &#039;application/vnd.kahootz&#039;, &#039;kwd&#039; =&gt; &#039;application/vnd.kde.kword&#039;, &#039;kwt&#039; =&gt; &#039;application/vnd.kde.kword&#039;, &#039;lasxml&#039; =&gt; &#039;application/vnd.las.las+xml&#039;, &#039;latex&#039; =&gt; &#039;application/x-latex&#039;, &#039;lbd&#039; =&gt; &#039;application/vnd.llamagraphics.life-balance.desktop&#039;, &#039;lbe&#039; =&gt; &#039;application/vnd.llamagraphics.life-balance.exchange+xml&#039;, &#039;les&#039; =&gt; &#039;application/vnd.hhe.lesson-player&#039;, &#039;less&#039; =&gt; &#039;text/less&#039;, &#039;lgr&#039; =&gt; &#039;application/lgr+xml&#039;, &#039;lha&#039; =&gt; &#039;application/octet-stream&#039;, &#039;link66&#039; =&gt; &#039;application/vnd.route66.link66+xml&#039;, &#039;list&#039; =&gt; &#039;text/plain&#039;, &#039;list3820&#039; =&gt; &#039;application/vnd.ibm.modcap&#039;, &#039;listafp&#039; =&gt; &#039;application/vnd.ibm.modcap&#039;, &#039;litcoffee&#039; =&gt; &#039;text/coffeescript&#039;, &#039;lnk&#039; =&gt; &#039;application/x-ms-shortcut&#039;, &#039;log&#039; =&gt; &#039;text/plain&#039;, &#039;lostxml&#039; =&gt; &#039;application/lost+xml&#039;, &#039;lrf&#039; =&gt; &#039;application/octet-stream&#039;, &#039;lrm&#039; =&gt; &#039;application/vnd.ms-lrm&#039;, &#039;ltf&#039; =&gt; &#039;application/vnd.frogans.ltf&#039;, &#039;lua&#039; =&gt; &#039;text/x-lua&#039;, &#039;luac&#039; =&gt; &#039;application/x-lua-bytecode&#039;, &#039;lvp&#039; =&gt; &#039;audio/vnd.lucent.voice&#039;, &#039;lwp&#039; =&gt; &#039;application/vnd.lotus-wordpro&#039;, &#039;lzh&#039; =&gt; &#039;application/octet-stream&#039;, &#039;m1v&#039; =&gt; &#039;video/mpeg&#039;, &#039;m2a&#039; =&gt; &#039;audio/mpeg&#039;, &#039;m2v&#039; =&gt; &#039;video/mpeg&#039;, &#039;m3a&#039; =&gt; &#039;audio/mpeg&#039;, &#039;m3u&#039; =&gt; &#039;text/plain&#039;, &#039;m3u8&#039; =&gt; &#039;application/vnd.apple.mpegurl&#039;, &#039;m4a&#039; =&gt; &#039;audio/x-m4a&#039;, &#039;m4p&#039; =&gt; &#039;application/mp4&#039;, &#039;m4s&#039; =&gt; &#039;video/iso.segment&#039;, &#039;m4u&#039; =&gt; &#039;application/vnd.mpegurl&#039;, &#039;m4v&#039; =&gt; &#039;video/x-m4v&#039;, &#039;m13&#039; =&gt; &#039;application/x-msmediaview&#039;, &#039;m14&#039; =&gt; &#039;application/x-msmediaview&#039;, &#039;m21&#039; =&gt; &#039;application/mp21&#039;, &#039;ma&#039; =&gt; &#039;application/mathematica&#039;, &#039;mads&#039; =&gt; &#039;application/mads+xml&#039;, &#039;maei&#039; =&gt; &#039;application/mmt-aei+xml&#039;, &#039;mag&#039; =&gt; &#039;application/vnd.ecowin.chart&#039;, &#039;maker&#039; =&gt; &#039;application/vnd.framemaker&#039;, &#039;man&#039; =&gt; &#039;text/troff&#039;, &#039;manifest&#039; =&gt; &#039;text/cache-manifest&#039;, &#039;map&#039; =&gt; &#039;application/json&#039;, &#039;mar&#039; =&gt; &#039;application/octet-stream&#039;, &#039;markdown&#039; =&gt; &#039;text/markdown&#039;, &#039;mathml&#039; =&gt; &#039;application/mathml+xml&#039;, &#039;mb&#039; =&gt; &#039;application/mathematica&#039;, &#039;mbk&#039; =&gt; &#039;application/vnd.mobius.mbk&#039;, &#039;mbox&#039; =&gt; &#039;application/mbox&#039;, &#039;mc1&#039; =&gt; &#039;application/vnd.medcalcdata&#039;, &#039;mcd&#039; =&gt; &#039;application/vnd.mcd&#039;, &#039;mcurl&#039; =&gt; &#039;text/vnd.curl.mcurl&#039;, &#039;md&#039; =&gt; &#039;text/markdown&#039;, &#039;mdb&#039; =&gt; &#039;application/x-msaccess&#039;, &#039;mdi&#039; =&gt; &#039;image/vnd.ms-modi&#039;, &#039;mdx&#039; =&gt; &#039;text/mdx&#039;, &#039;me&#039; =&gt; &#039;text/troff&#039;, &#039;mesh&#039; =&gt; &#039;model/mesh&#039;, &#039;meta4&#039; =&gt; &#039;application/metalink4+xml&#039;, &#039;metalink&#039; =&gt; &#039;application/metalink+xml&#039;, &#039;mets&#039; =&gt; &#039;application/mets+xml&#039;, &#039;mfm&#039; =&gt; &#039;application/vnd.mfmp&#039;, &#039;mft&#039; =&gt; &#039;application/rpki-manifest&#039;, &#039;mgp&#039; =&gt; &#039;application/vnd.osgeo.mapguide.package&#039;, &#039;mgz&#039; =&gt; &#039;application/vnd.proteus.magazine&#039;, &#039;mid&#039; =&gt; &#039;audio/midi&#039;, &#039;midi&#039; =&gt; &#039;audio/midi&#039;, &#039;mie&#039; =&gt; &#039;application/x-mie&#039;, &#039;mif&#039; =&gt; &#039;application/vnd.mif&#039;, &#039;mime&#039; =&gt; &#039;message/rfc822&#039;, &#039;mj2&#039; =&gt; &#039;video/mj2&#039;, &#039;mjp2&#039; =&gt; &#039;video/mj2&#039;, &#039;mjs&#039; =&gt; &#039;application/javascript&#039;, &#039;mk3d&#039; =&gt; &#039;video/x-matroska&#039;, &#039;mka&#039; =&gt; &#039;audio/x-matroska&#039;, &#039;mkd&#039; =&gt; &#039;text/x-markdown&#039;, &#039;mks&#039; =&gt; &#039;video/x-matroska&#039;, &#039;mkv&#039; =&gt; &#039;video/x-matroska&#039;, &#039;mlp&#039; =&gt; &#039;application/vnd.dolby.mlp&#039;, &#039;mmd&#039; =&gt; &#039;application/vnd.chipnuts.karaoke-mmd&#039;, &#039;mmf&#039; =&gt; &#039;application/vnd.smaf&#039;, &#039;mml&#039; =&gt; &#039;text/mathml&#039;, &#039;mmr&#039; =&gt; &#039;image/vnd.fujixerox.edmics-mmr&#039;, &#039;mng&#039; =&gt; &#039;video/x-mng&#039;, &#039;mny&#039; =&gt; &#039;application/x-msmoney&#039;, &#039;mobi&#039; =&gt; &#039;application/x-mobipocket-ebook&#039;, &#039;mods&#039; =&gt; &#039;application/mods+xml&#039;, &#039;mov&#039; =&gt; &#039;video/quicktime&#039;, &#039;movie&#039; =&gt; &#039;video/x-sgi-movie&#039;, &#039;mp2&#039; =&gt; &#039;audio/mpeg&#039;, &#039;mp2a&#039; =&gt; &#039;audio/mpeg&#039;, &#039;mp3&#039; =&gt; &#039;audio/mpeg&#039;, &#039;mp4&#039; =&gt; &#039;video/mp4&#039;, &#039;mp4a&#039; =&gt; &#039;audio/mp4&#039;, &#039;mp4s&#039; =&gt; &#039;application/mp4&#039;, &#039;mp4v&#039; =&gt; &#039;video/mp4&#039;, &#039;mp21&#039; =&gt; &#039;application/mp21&#039;, &#039;mpc&#039; =&gt; &#039;application/vnd.mophun.certificate&#039;, &#039;mpd&#039; =&gt; &#039;application/dash+xml&#039;, &#039;mpe&#039; =&gt; &#039;video/mpeg&#039;, &#039;mpeg&#039; =&gt; &#039;video/mpeg&#039;, &#039;mpf&#039; =&gt; &#039;application/media-policy-dataset+xml&#039;, &#039;mpg&#039; =&gt; &#039;video/mpeg&#039;, &#039;mpg4&#039; =&gt; &#039;video/mp4&#039;, &#039;mpga&#039; =&gt; &#039;audio/mpeg&#039;, &#039;mpkg&#039; =&gt; &#039;application/vnd.apple.installer+xml&#039;, &#039;mpm&#039; =&gt; &#039;application/vnd.blueice.multipass&#039;, &#039;mpn&#039; =&gt; &#039;application/vnd.mophun.application&#039;, &#039;mpp&#039; =&gt; &#039;application/vnd.ms-project&#039;, &#039;mpt&#039; =&gt; &#039;application/vnd.ms-project&#039;, &#039;mpy&#039; =&gt; &#039;application/vnd.ibm.minipay&#039;, &#039;mqy&#039; =&gt; &#039;application/vnd.mobius.mqy&#039;, &#039;mrc&#039; =&gt; &#039;application/marc&#039;, &#039;mrcx&#039; =&gt; &#039;application/marcxml+xml&#039;, &#039;ms&#039; =&gt; &#039;text/troff&#039;, &#039;mscml&#039; =&gt; &#039;application/mediaservercontrol+xml&#039;, &#039;mseed&#039; =&gt; &#039;application/vnd.fdsn.mseed&#039;, &#039;mseq&#039; =&gt; &#039;application/vnd.mseq&#039;, &#039;msf&#039; =&gt; &#039;application/vnd.epson.msf&#039;, &#039;msg&#039; =&gt; &#039;application/vnd.ms-outlook&#039;, &#039;msh&#039; =&gt; &#039;model/mesh&#039;, &#039;msi&#039; =&gt; &#039;application/x-msdownload&#039;, &#039;msl&#039; =&gt; &#039;application/vnd.mobius.msl&#039;, &#039;msm&#039; =&gt; &#039;application/octet-stream&#039;, &#039;msp&#039; =&gt; &#039;application/octet-stream&#039;, &#039;msty&#039; =&gt; &#039;application/vnd.muvee.style&#039;, &#039;mtl&#039; =&gt; &#039;model/mtl&#039;, &#039;mts&#039; =&gt; &#039;model/vnd.mts&#039;, &#039;mus&#039; =&gt; &#039;application/vnd.musician&#039;, &#039;musd&#039; =&gt; &#039;application/mmt-usd+xml&#039;, &#039;musicxml&#039; =&gt; &#039;application/vnd.recordare.musicxml+xml&#039;, &#039;mvb&#039; =&gt; &#039;application/x-msmediaview&#039;, &#039;mvt&#039; =&gt; &#039;application/vnd.mapbox-vector-tile&#039;, &#039;mwf&#039; =&gt; &#039;application/vnd.mfer&#039;, &#039;mxf&#039; =&gt; &#039;application/mxf&#039;, &#039;mxl&#039; =&gt; &#039;application/vnd.recordare.musicxml&#039;, &#039;mxmf&#039; =&gt; &#039;audio/mobile-xmf&#039;, &#039;mxml&#039; =&gt; &#039;application/xv+xml&#039;, &#039;mxs&#039; =&gt; &#039;application/vnd.triscape.mxs&#039;, &#039;mxu&#039; =&gt; &#039;video/vnd.mpegurl&#039;, &#039;n-gage&#039; =&gt; &#039;application/vnd.nokia.n-gage.symbian.install&#039;, &#039;n3&#039; =&gt; &#039;text/n3&#039;, &#039;nb&#039; =&gt; &#039;application/mathematica&#039;, &#039;nbp&#039; =&gt; &#039;application/vnd.wolfram.player&#039;, &#039;nc&#039; =&gt; &#039;application/x-netcdf&#039;, &#039;ncx&#039; =&gt; &#039;application/x-dtbncx+xml&#039;, &#039;nfo&#039; =&gt; &#039;text/x-nfo&#039;, &#039;ngdat&#039; =&gt; &#039;application/vnd.nokia.n-gage.data&#039;, &#039;nitf&#039; =&gt; &#039;application/vnd.nitf&#039;, &#039;nlu&#039; =&gt; &#039;application/vnd.neurolanguage.nlu&#039;, &#039;nml&#039; =&gt; &#039;application/vnd.enliven&#039;, &#039;nnd&#039; =&gt; &#039;application/vnd.noblenet-directory&#039;, &#039;nns&#039; =&gt; &#039;application/vnd.noblenet-sealer&#039;, &#039;nnw&#039; =&gt; &#039;application/vnd.noblenet-web&#039;, &#039;npx&#039; =&gt; &#039;image/vnd.net-fpx&#039;, &#039;nq&#039; =&gt; &#039;application/n-quads&#039;, &#039;nsc&#039; =&gt; &#039;application/x-conference&#039;, &#039;nsf&#039; =&gt; &#039;application/vnd.lotus-notes&#039;, &#039;nt&#039; =&gt; &#039;application/n-triples&#039;, &#039;ntf&#039; =&gt; &#039;application/vnd.nitf&#039;, &#039;numbers&#039; =&gt; &#039;application/x-iwork-numbers-sffnumbers&#039;, &#039;nzb&#039; =&gt; &#039;application/x-nzb&#039;, &#039;oa2&#039; =&gt; &#039;application/vnd.fujitsu.oasys2&#039;, &#039;oa3&#039; =&gt; &#039;application/vnd.fujitsu.oasys3&#039;, &#039;oas&#039; =&gt; &#039;application/vnd.fujitsu.oasys&#039;, &#039;obd&#039; =&gt; &#039;application/x-msbinder&#039;, &#039;obgx&#039; =&gt; &#039;application/vnd.openblox.game+xml&#039;, &#039;obj&#039; =&gt; &#039;model/obj&#039;, &#039;oda&#039; =&gt; &#039;application/oda&#039;, &#039;odb&#039; =&gt; &#039;application/vnd.oasis.opendocument.database&#039;, &#039;odc&#039; =&gt; &#039;application/vnd.oasis.opendocument.chart&#039;, &#039;odf&#039; =&gt; &#039;application/vnd.oasis.opendocument.formula&#039;, &#039;odft&#039; =&gt; &#039;application/vnd.oasis.opendocument.formula-template&#039;, &#039;odg&#039; =&gt; &#039;application/vnd.oasis.opendocument.graphics&#039;, &#039;odi&#039; =&gt; &#039;application/vnd.oasis.opendocument.image&#039;, &#039;odm&#039; =&gt; &#039;application/vnd.oasis.opendocument.text-master&#039;, &#039;odp&#039; =&gt; &#039;application/vnd.oasis.opendocument.presentation&#039;, &#039;ods&#039; =&gt; &#039;application/vnd.oasis.opendocument.spreadsheet&#039;, &#039;odt&#039; =&gt; &#039;application/vnd.oasis.opendocument.text&#039;, &#039;oga&#039; =&gt; &#039;audio/ogg&#039;, &#039;ogex&#039; =&gt; &#039;model/vnd.opengex&#039;, &#039;ogg&#039; =&gt; &#039;audio/ogg&#039;, &#039;ogv&#039; =&gt; &#039;video/ogg&#039;, &#039;ogx&#039; =&gt; &#039;application/ogg&#039;, &#039;omdoc&#039; =&gt; &#039;application/omdoc+xml&#039;, &#039;onepkg&#039; =&gt; &#039;application/onenote&#039;, &#039;onetmp&#039; =&gt; &#039;application/onenote&#039;, &#039;onetoc&#039; =&gt; &#039;application/onenote&#039;, &#039;onetoc2&#039; =&gt; &#039;application/onenote&#039;, &#039;opf&#039; =&gt; &#039;application/oebps-package+xml&#039;, &#039;opml&#039; =&gt; &#039;text/x-opml&#039;, &#039;oprc&#039; =&gt; &#039;application/vnd.palm&#039;, &#039;opus&#039; =&gt; &#039;audio/ogg&#039;, &#039;org&#039; =&gt; &#039;text/x-org&#039;, &#039;osf&#039; =&gt; &#039;application/vnd.yamaha.openscoreformat&#039;, &#039;osfpvg&#039; =&gt; &#039;application/vnd.yamaha.openscoreformat.osfpvg+xml&#039;, &#039;osm&#039; =&gt; &#039;application/vnd.openstreetmap.data+xml&#039;, &#039;otc&#039; =&gt; &#039;application/vnd.oasis.opendocument.chart-template&#039;, &#039;otf&#039; =&gt; &#039;font/otf&#039;, &#039;otg&#039; =&gt; &#039;application/vnd.oasis.opendocument.graphics-template&#039;, &#039;oth&#039; =&gt; &#039;application/vnd.oasis.opendocument.text-web&#039;, &#039;oti&#039; =&gt; &#039;application/vnd.oasis.opendocument.image-template&#039;, &#039;otp&#039; =&gt; &#039;application/vnd.oasis.opendocument.presentation-template&#039;, &#039;ots&#039; =&gt; &#039;application/vnd.oasis.opendocument.spreadsheet-template&#039;, &#039;ott&#039; =&gt; &#039;application/vnd.oasis.opendocument.text-template&#039;, &#039;ova&#039; =&gt; &#039;application/x-virtualbox-ova&#039;, &#039;ovf&#039; =&gt; &#039;application/x-virtualbox-ovf&#039;, &#039;owl&#039; =&gt; &#039;application/rdf+xml&#039;, &#039;oxps&#039; =&gt; &#039;application/oxps&#039;, &#039;oxt&#039; =&gt; &#039;application/vnd.openofficeorg.extension&#039;, &#039;p&#039; =&gt; &#039;text/x-pascal&#039;, &#039;p7a&#039; =&gt; &#039;application/x-pkcs7-signature&#039;, &#039;p7b&#039; =&gt; &#039;application/x-pkcs7-certificates&#039;, &#039;p7c&#039; =&gt; &#039;application/pkcs7-mime&#039;, &#039;p7m&#039; =&gt; &#039;application/pkcs7-mime&#039;, &#039;p7r&#039; =&gt; &#039;application/x-pkcs7-certreqresp&#039;, &#039;p7s&#039; =&gt; &#039;application/pkcs7-signature&#039;, &#039;p8&#039; =&gt; &#039;application/pkcs8&#039;, &#039;p10&#039; =&gt; &#039;application/x-pkcs10&#039;, &#039;p12&#039; =&gt; &#039;application/x-pkcs12&#039;, &#039;pac&#039; =&gt; &#039;application/x-ns-proxy-autoconfig&#039;, &#039;pages&#039; =&gt; &#039;application/x-iwork-pages-sffpages&#039;, &#039;pas&#039; =&gt; &#039;text/x-pascal&#039;, &#039;paw&#039; =&gt; &#039;application/vnd.pawaafile&#039;, &#039;pbd&#039; =&gt; &#039;application/vnd.powerbuilder6&#039;, &#039;pbm&#039; =&gt; &#039;image/x-portable-bitmap&#039;, &#039;pcap&#039; =&gt; &#039;application/vnd.tcpdump.pcap&#039;, &#039;pcf&#039; =&gt; &#039;application/x-font-pcf&#039;, &#039;pcl&#039; =&gt; &#039;application/vnd.hp-pcl&#039;, &#039;pclxl&#039; =&gt; &#039;application/vnd.hp-pclxl&#039;, &#039;pct&#039; =&gt; &#039;image/x-pict&#039;, &#039;pcurl&#039; =&gt; &#039;application/vnd.curl.pcurl&#039;, &#039;pcx&#039; =&gt; &#039;image/x-pcx&#039;, &#039;pdb&#039; =&gt; &#039;application/x-pilot&#039;, &#039;pde&#039; =&gt; &#039;text/x-processing&#039;, &#039;pdf&#039; =&gt; &#039;application/pdf&#039;, &#039;pem&#039; =&gt; &#039;application/x-x509-user-cert&#039;, &#039;pfa&#039; =&gt; &#039;application/x-font-type1&#039;, &#039;pfb&#039; =&gt; &#039;application/x-font-type1&#039;, &#039;pfm&#039; =&gt; &#039;application/x-font-type1&#039;, &#039;pfr&#039; =&gt; &#039;application/font-tdpfr&#039;, &#039;pfx&#039; =&gt; &#039;application/x-pkcs12&#039;, &#039;pgm&#039; =&gt; &#039;image/x-portable-graymap&#039;, &#039;pgn&#039; =&gt; &#039;application/x-chess-pgn&#039;, &#039;pgp&#039; =&gt; &#039;application/pgp&#039;, &#039;phar&#039; =&gt; &#039;application/octet-stream&#039;, &#039;php&#039; =&gt; &#039;application/x-httpd-php&#039;, &#039;php3&#039; =&gt; &#039;application/x-httpd-php&#039;, &#039;php4&#039; =&gt; &#039;application/x-httpd-php&#039;, &#039;phps&#039; =&gt; &#039;application/x-httpd-php-source&#039;, &#039;phtml&#039; =&gt; &#039;application/x-httpd-php&#039;, &#039;pic&#039; =&gt; &#039;image/x-pict&#039;, &#039;pkg&#039; =&gt; &#039;application/octet-stream&#039;, &#039;pki&#039; =&gt; &#039;application/pkixcmp&#039;, &#039;pkipath&#039; =&gt; &#039;application/pkix-pkipath&#039;, &#039;pkpass&#039; =&gt; &#039;application/vnd.apple.pkpass&#039;, &#039;pl&#039; =&gt; &#039;application/x-perl&#039;, &#039;plb&#039; =&gt; &#039;application/vnd.3gpp.pic-bw-large&#039;, &#039;plc&#039; =&gt; &#039;application/vnd.mobius.plc&#039;, &#039;plf&#039; =&gt; &#039;application/vnd.pocketlearn&#039;, &#039;pls&#039; =&gt; &#039;application/pls+xml&#039;, &#039;pm&#039; =&gt; &#039;application/x-perl&#039;, &#039;pml&#039; =&gt; &#039;application/vnd.ctc-posml&#039;, &#039;png&#039; =&gt; &#039;image/png&#039;, &#039;pnm&#039; =&gt; &#039;image/x-portable-anymap&#039;, &#039;portpkg&#039; =&gt; &#039;application/vnd.macports.portpkg&#039;, &#039;pot&#039; =&gt; &#039;application/vnd.ms-powerpoint&#039;, &#039;potm&#039; =&gt; &#039;application/vnd.ms-powerpoint.presentation.macroEnabled.12&#039;, &#039;potx&#039; =&gt; &#039;application/vnd.openxmlformats-officedocument.presentationml.template&#039;, &#039;ppa&#039; =&gt; &#039;application/vnd.ms-powerpoint&#039;, &#039;ppam&#039; =&gt; &#039;application/vnd.ms-powerpoint.addin.macroEnabled.12&#039;, &#039;ppd&#039; =&gt; &#039;application/vnd.cups-ppd&#039;, &#039;ppm&#039; =&gt; &#039;image/x-portable-pixmap&#039;, &#039;pps&#039; =&gt; &#039;application/vnd.ms-powerpoint&#039;, &#039;ppsm&#039; =&gt; &#039;application/vnd.ms-powerpoint.slideshow.macroEnabled.12&#039;, &#039;ppsx&#039; =&gt; &#039;application/vnd.openxmlformats-officedocument.presentationml.slideshow&#039;, &#039;ppt&#039; =&gt; &#039;application/powerpoint&#039;, &#039;pptm&#039; =&gt; &#039;application/vnd.ms-powerpoint.presentation.macroEnabled.12&#039;, &#039;pptx&#039; =&gt; &#039;application/vnd.openxmlformats-officedocument.presentationml.presentation&#039;, &#039;pqa&#039; =&gt; &#039;application/vnd.palm&#039;, &#039;prc&#039; =&gt; &#039;model/prc&#039;, &#039;pre&#039; =&gt; &#039;application/vnd.lotus-freelance&#039;, &#039;prf&#039; =&gt; &#039;application/pics-rules&#039;, &#039;provx&#039; =&gt; &#039;application/provenance+xml&#039;, &#039;ps&#039; =&gt; &#039;application/postscript&#039;, &#039;psb&#039; =&gt; &#039;application/vnd.3gpp.pic-bw-small&#039;, &#039;psd&#039; =&gt; &#039;application/x-photoshop&#039;, &#039;psf&#039; =&gt; &#039;application/x-font-linux-psf&#039;, &#039;pskcxml&#039; =&gt; &#039;application/pskc+xml&#039;, &#039;pti&#039; =&gt; &#039;image/prs.pti&#039;, &#039;ptid&#039; =&gt; &#039;application/vnd.pvi.ptid1&#039;, &#039;pub&#039; =&gt; &#039;application/x-mspublisher&#039;, &#039;pvb&#039; =&gt; &#039;application/vnd.3gpp.pic-bw-var&#039;, &#039;pwn&#039; =&gt; &#039;application/vnd.3m.post-it-notes&#039;, &#039;pya&#039; =&gt; &#039;audio/vnd.ms-playready.media.pya&#039;, &#039;pyv&#039; =&gt; &#039;video/vnd.ms-playready.media.pyv&#039;, &#039;qam&#039; =&gt; &#039;application/vnd.epson.quickanime&#039;, &#039;qbo&#039; =&gt; &#039;application/vnd.intu.qbo&#039;, &#039;qfx&#039; =&gt; &#039;application/vnd.intu.qfx&#039;, &#039;qps&#039; =&gt; &#039;application/vnd.publishare-delta-tree&#039;, &#039;qt&#039; =&gt; &#039;video/quicktime&#039;, &#039;qwd&#039; =&gt; &#039;application/vnd.quark.quarkxpress&#039;, &#039;qwt&#039; =&gt; &#039;application/vnd.quark.quarkxpress&#039;, &#039;qxb&#039; =&gt; &#039;application/vnd.quark.quarkxpress&#039;, &#039;qxd&#039; =&gt; &#039;application/vnd.quark.quarkxpress&#039;, &#039;qxl&#039; =&gt; &#039;application/vnd.quark.quarkxpress&#039;, &#039;qxt&#039; =&gt; &#039;application/vnd.quark.quarkxpress&#039;, &#039;ra&#039; =&gt; &#039;audio/x-realaudio&#039;, &#039;ram&#039; =&gt; &#039;audio/x-pn-realaudio&#039;, &#039;raml&#039; =&gt; &#039;application/raml+yaml&#039;, &#039;rapd&#039; =&gt; &#039;application/route-apd+xml&#039;, &#039;rar&#039; =&gt; &#039;application/x-rar&#039;, &#039;ras&#039; =&gt; &#039;image/x-cmu-raster&#039;, &#039;rcprofile&#039; =&gt; &#039;application/vnd.ipunplugged.rcprofile&#039;, &#039;rdf&#039; =&gt; &#039;application/rdf+xml&#039;, &#039;rdz&#039; =&gt; &#039;application/vnd.data-vision.rdz&#039;, &#039;relo&#039; =&gt; &#039;application/p2p-overlay+xml&#039;, &#039;rep&#039; =&gt; &#039;application/vnd.businessobjects&#039;, &#039;res&#039; =&gt; &#039;application/x-dtbresource+xml&#039;, &#039;rgb&#039; =&gt; &#039;image/x-rgb&#039;, &#039;rif&#039; =&gt; &#039;application/reginfo+xml&#039;, &#039;rip&#039; =&gt; &#039;audio/vnd.rip&#039;, &#039;ris&#039; =&gt; &#039;application/x-research-info-systems&#039;, &#039;rl&#039; =&gt; &#039;application/resource-lists+xml&#039;, &#039;rlc&#039; =&gt; &#039;image/vnd.fujixerox.edmics-rlc&#039;, &#039;rld&#039; =&gt; &#039;application/resource-lists-diff+xml&#039;, &#039;rm&#039; =&gt; &#039;audio/x-pn-realaudio&#039;, &#039;rmi&#039; =&gt; &#039;audio/midi&#039;, &#039;rmp&#039; =&gt; &#039;audio/x-pn-realaudio-plugin&#039;, &#039;rms&#039; =&gt; &#039;application/vnd.jcp.javame.midlet-rms&#039;, &#039;rmvb&#039; =&gt; &#039;application/vnd.rn-realmedia-vbr&#039;, &#039;rnc&#039; =&gt; &#039;application/relax-ng-compact-syntax&#039;, &#039;rng&#039; =&gt; &#039;application/xml&#039;, &#039;roa&#039; =&gt; &#039;application/rpki-roa&#039;, &#039;roff&#039; =&gt; &#039;text/troff&#039;, &#039;rp9&#039; =&gt; &#039;application/vnd.cloanto.rp9&#039;, &#039;rpm&#039; =&gt; &#039;audio/x-pn-realaudio-plugin&#039;, &#039;rpss&#039; =&gt; &#039;application/vnd.nokia.radio-presets&#039;, &#039;rpst&#039; =&gt; &#039;application/vnd.nokia.radio-preset&#039;, &#039;rq&#039; =&gt; &#039;application/sparql-query&#039;, &#039;rs&#039; =&gt; &#039;application/rls-services+xml&#039;, &#039;rsa&#039; =&gt; &#039;application/x-pkcs7&#039;, &#039;rsat&#039; =&gt; &#039;application/atsc-rsat+xml&#039;, &#039;rsd&#039; =&gt; &#039;application/rsd+xml&#039;, &#039;rsheet&#039; =&gt; &#039;application/urc-ressheet+xml&#039;, &#039;rss&#039; =&gt; &#039;application/rss+xml&#039;, &#039;rtf&#039; =&gt; &#039;text/rtf&#039;, &#039;rtx&#039; =&gt; &#039;text/richtext&#039;, &#039;run&#039; =&gt; &#039;application/x-makeself&#039;, &#039;rusd&#039; =&gt; &#039;application/route-usd+xml&#039;, &#039;rv&#039; =&gt; &#039;video/vnd.rn-realvideo&#039;, &#039;s&#039; =&gt; &#039;text/x-asm&#039;, &#039;s3m&#039; =&gt; &#039;audio/s3m&#039;, &#039;saf&#039; =&gt; &#039;application/vnd.yamaha.smaf-audio&#039;, &#039;sass&#039; =&gt; &#039;text/x-sass&#039;, &#039;sbml&#039; =&gt; &#039;application/sbml+xml&#039;, &#039;sc&#039; =&gt; &#039;application/vnd.ibm.secure-container&#039;, &#039;scd&#039; =&gt; &#039;application/x-msschedule&#039;, &#039;scm&#039; =&gt; &#039;application/vnd.lotus-screencam&#039;, &#039;scq&#039; =&gt; &#039;application/scvp-cv-request&#039;, &#039;scs&#039; =&gt; &#039;application/scvp-cv-response&#039;, &#039;scss&#039; =&gt; &#039;text/x-scss&#039;, &#039;scurl&#039; =&gt; &#039;text/vnd.curl.scurl&#039;, &#039;sda&#039; =&gt; &#039;application/vnd.stardivision.draw&#039;, &#039;sdc&#039; =&gt; &#039;application/vnd.stardivision.calc&#039;, &#039;sdd&#039; =&gt; &#039;application/vnd.stardivision.impress&#039;, &#039;sdkd&#039; =&gt; &#039;application/vnd.solent.sdkm+xml&#039;, &#039;sdkm&#039; =&gt; &#039;application/vnd.solent.sdkm+xml&#039;, &#039;sdp&#039; =&gt; &#039;application/sdp&#039;, &#039;sdw&#039; =&gt; &#039;application/vnd.stardivision.writer&#039;, &#039;sea&#039; =&gt; &#039;application/octet-stream&#039;, &#039;see&#039; =&gt; &#039;application/vnd.seemail&#039;, &#039;seed&#039; =&gt; &#039;application/vnd.fdsn.seed&#039;, &#039;sema&#039; =&gt; &#039;application/vnd.sema&#039;, &#039;semd&#039; =&gt; &#039;application/vnd.semd&#039;, &#039;semf&#039; =&gt; &#039;application/vnd.semf&#039;, &#039;senmlx&#039; =&gt; &#039;application/senml+xml&#039;, &#039;sensmlx&#039; =&gt; &#039;application/sensml+xml&#039;, &#039;ser&#039; =&gt; &#039;application/java-serialized-object&#039;, &#039;setpay&#039; =&gt; &#039;application/set-payment-initiation&#039;, &#039;setreg&#039; =&gt; &#039;application/set-registration-initiation&#039;, &#039;sfd-hdstx&#039; =&gt; &#039;application/vnd.hydrostatix.sof-data&#039;, &#039;sfs&#039; =&gt; &#039;application/vnd.spotfire.sfs&#039;, &#039;sfv&#039; =&gt; &#039;text/x-sfv&#039;, &#039;sgi&#039; =&gt; &#039;image/sgi&#039;, &#039;sgl&#039; =&gt; &#039;application/vnd.stardivision.writer-global&#039;, &#039;sgm&#039; =&gt; &#039;text/sgml&#039;, &#039;sgml&#039; =&gt; &#039;text/sgml&#039;, &#039;sh&#039; =&gt; &#039;application/x-sh&#039;, &#039;shar&#039; =&gt; &#039;application/x-shar&#039;, &#039;shex&#039; =&gt; &#039;text/shex&#039;, &#039;shf&#039; =&gt; &#039;application/shf+xml&#039;, &#039;shtml&#039; =&gt; &#039;text/html&#039;, &#039;sid&#039; =&gt; &#039;image/x-mrsid-image&#039;, &#039;sieve&#039; =&gt; &#039;application/sieve&#039;, &#039;sig&#039; =&gt; &#039;application/pgp-signature&#039;, &#039;sil&#039; =&gt; &#039;audio/silk&#039;, &#039;silo&#039; =&gt; &#039;model/mesh&#039;, &#039;sis&#039; =&gt; &#039;application/vnd.symbian.install&#039;, &#039;sisx&#039; =&gt; &#039;application/vnd.symbian.install&#039;, &#039;sit&#039; =&gt; &#039;application/x-stuffit&#039;, &#039;sitx&#039; =&gt; &#039;application/x-stuffitx&#039;, &#039;siv&#039; =&gt; &#039;application/sieve&#039;, &#039;skd&#039; =&gt; &#039;application/vnd.koan&#039;, &#039;skm&#039; =&gt; &#039;application/vnd.koan&#039;, &#039;skp&#039; =&gt; &#039;application/vnd.koan&#039;, &#039;skt&#039; =&gt; &#039;application/vnd.koan&#039;, &#039;sldm&#039; =&gt; &#039;application/vnd.ms-powerpoint.slide.macroenabled.12&#039;, &#039;sldx&#039; =&gt; &#039;application/vnd.openxmlformats-officedocument.presentationml.slide&#039;, &#039;slim&#039; =&gt; &#039;text/slim&#039;, &#039;slm&#039; =&gt; &#039;text/slim&#039;, &#039;sls&#039; =&gt; &#039;application/route-s-tsid+xml&#039;, &#039;slt&#039; =&gt; &#039;application/vnd.epson.salt&#039;, &#039;sm&#039; =&gt; &#039;application/vnd.stepmania.stepchart&#039;, &#039;smf&#039; =&gt; &#039;application/vnd.stardivision.math&#039;, &#039;smi&#039; =&gt; &#039;application/smil&#039;, &#039;smil&#039; =&gt; &#039;application/smil&#039;, &#039;smv&#039; =&gt; &#039;video/x-smv&#039;, &#039;smzip&#039; =&gt; &#039;application/vnd.stepmania.package&#039;, &#039;snd&#039; =&gt; &#039;audio/basic&#039;, &#039;snf&#039; =&gt; &#039;application/x-font-snf&#039;, &#039;so&#039; =&gt; &#039;application/octet-stream&#039;, &#039;spc&#039; =&gt; &#039;application/x-pkcs7-certificates&#039;, &#039;spdx&#039; =&gt; &#039;text/spdx&#039;, &#039;spf&#039; =&gt; &#039;application/vnd.yamaha.smaf-phrase&#039;, &#039;spl&#039; =&gt; &#039;application/x-futuresplash&#039;, &#039;spot&#039; =&gt; &#039;text/vnd.in3d.spot&#039;, &#039;spp&#039; =&gt; &#039;application/scvp-vp-response&#039;, &#039;spq&#039; =&gt; &#039;application/scvp-vp-request&#039;, &#039;spx&#039; =&gt; &#039;audio/ogg&#039;, &#039;sql&#039; =&gt; &#039;application/x-sql&#039;, &#039;src&#039; =&gt; &#039;application/x-wais-source&#039;, &#039;srt&#039; =&gt; &#039;application/x-subrip&#039;, &#039;sru&#039; =&gt; &#039;application/sru+xml&#039;, &#039;srx&#039; =&gt; &#039;application/sparql-results+xml&#039;, &#039;ssdl&#039; =&gt; &#039;application/ssdl+xml&#039;, &#039;sse&#039; =&gt; &#039;application/vnd.kodak-descriptor&#039;, &#039;ssf&#039; =&gt; &#039;application/vnd.epson.ssf&#039;, &#039;ssml&#039; =&gt; &#039;application/ssml+xml&#039;, &#039;sst&#039; =&gt; &#039;application/octet-stream&#039;, &#039;st&#039; =&gt; &#039;application/vnd.sailingtracker.track&#039;, &#039;stc&#039; =&gt; &#039;application/vnd.sun.xml.calc.template&#039;, &#039;std&#039; =&gt; &#039;application/vnd.sun.xml.draw.template&#039;, &#039;stf&#039; =&gt; &#039;application/vnd.wt.stf&#039;, &#039;sti&#039; =&gt; &#039;application/vnd.sun.xml.impress.template&#039;, &#039;stk&#039; =&gt; &#039;application/hyperstudio&#039;, &#039;stl&#039; =&gt; &#039;model/stl&#039;, &#039;stpx&#039; =&gt; &#039;model/step+xml&#039;, &#039;stpxz&#039; =&gt; &#039;model/step-xml+zip&#039;, &#039;stpz&#039; =&gt; &#039;model/step+zip&#039;, &#039;str&#039; =&gt; &#039;application/vnd.pg.format&#039;, &#039;stw&#039; =&gt; &#039;application/vnd.sun.xml.writer.template&#039;, &#039;styl&#039; =&gt; &#039;text/stylus&#039;, &#039;stylus&#039; =&gt; &#039;text/stylus&#039;, &#039;sub&#039; =&gt; &#039;text/vnd.dvb.subtitle&#039;, &#039;sus&#039; =&gt; &#039;application/vnd.sus-calendar&#039;, &#039;susp&#039; =&gt; &#039;application/vnd.sus-calendar&#039;, &#039;sv4cpio&#039; =&gt; &#039;application/x-sv4cpio&#039;, &#039;sv4crc&#039; =&gt; &#039;application/x-sv4crc&#039;, &#039;svc&#039; =&gt; &#039;application/vnd.dvb.service&#039;, &#039;svd&#039; =&gt; &#039;application/vnd.svd&#039;, &#039;svg&#039; =&gt; &#039;image/svg+xml&#039;, &#039;svgz&#039; =&gt; &#039;image/svg+xml&#039;, &#039;swa&#039; =&gt; &#039;application/x-director&#039;, &#039;swf&#039; =&gt; &#039;application/x-shockwave-flash&#039;, &#039;swi&#039; =&gt; &#039;application/vnd.aristanetworks.swi&#039;, &#039;swidtag&#039; =&gt; &#039;application/swid+xml&#039;, &#039;sxc&#039; =&gt; &#039;application/vnd.sun.xml.calc&#039;, &#039;sxd&#039; =&gt; &#039;application/vnd.sun.xml.draw&#039;, &#039;sxg&#039; =&gt; &#039;application/vnd.sun.xml.writer.global&#039;, &#039;sxi&#039; =&gt; &#039;application/vnd.sun.xml.impress&#039;, &#039;sxm&#039; =&gt; &#039;application/vnd.sun.xml.math&#039;, &#039;sxw&#039; =&gt; &#039;application/vnd.sun.xml.writer&#039;, &#039;t&#039; =&gt; &#039;text/troff&#039;, &#039;t3&#039; =&gt; &#039;application/x-t3vm-image&#039;, &#039;t38&#039; =&gt; &#039;image/t38&#039;, &#039;taglet&#039; =&gt; &#039;application/vnd.mynfc&#039;, &#039;tao&#039; =&gt; &#039;application/vnd.tao.intent-module-archive&#039;, &#039;tap&#039; =&gt; &#039;image/vnd.tencent.tap&#039;, &#039;tar&#039; =&gt; &#039;application/x-tar&#039;, &#039;tcap&#039; =&gt; &#039;application/vnd.3gpp2.tcap&#039;, &#039;tcl&#039; =&gt; &#039;application/x-tcl&#039;, &#039;td&#039; =&gt; &#039;application/urc-targetdesc+xml&#039;, &#039;teacher&#039; =&gt; &#039;application/vnd.smart.teacher&#039;, &#039;tei&#039; =&gt; &#039;application/tei+xml&#039;, &#039;teicorpus&#039; =&gt; &#039;application/tei+xml&#039;, &#039;tex&#039; =&gt; &#039;application/x-tex&#039;, &#039;texi&#039; =&gt; &#039;application/x-texinfo&#039;, &#039;texinfo&#039; =&gt; &#039;application/x-texinfo&#039;, &#039;text&#039; =&gt; &#039;text/plain&#039;, &#039;tfi&#039; =&gt; &#039;application/thraud+xml&#039;, &#039;tfm&#039; =&gt; &#039;application/x-tex-tfm&#039;, &#039;tfx&#039; =&gt; &#039;image/tiff-fx&#039;, &#039;tga&#039; =&gt; &#039;image/x-tga&#039;, &#039;tgz&#039; =&gt; &#039;application/x-tar&#039;, &#039;thmx&#039; =&gt; &#039;application/vnd.ms-officetheme&#039;, &#039;tif&#039; =&gt; &#039;image/tiff&#039;, &#039;tiff&#039; =&gt; &#039;image/tiff&#039;, &#039;tk&#039; =&gt; &#039;application/x-tcl&#039;, &#039;tmo&#039; =&gt; &#039;application/vnd.tmobile-livetv&#039;, &#039;toml&#039; =&gt; &#039;application/toml&#039;, &#039;torrent&#039; =&gt; &#039;application/x-bittorrent&#039;, &#039;tpl&#039; =&gt; &#039;application/vnd.groove-tool-template&#039;, &#039;tpt&#039; =&gt; &#039;application/vnd.trid.tpt&#039;, &#039;tr&#039; =&gt; &#039;text/troff&#039;, &#039;tra&#039; =&gt; &#039;application/vnd.trueapp&#039;, &#039;trig&#039; =&gt; &#039;application/trig&#039;, &#039;trm&#039; =&gt; &#039;application/x-msterminal&#039;, &#039;ts&#039; =&gt; &#039;video/mp2t&#039;, &#039;tsd&#039; =&gt; &#039;application/timestamped-data&#039;, &#039;tsv&#039; =&gt; &#039;text/tab-separated-values&#039;, &#039;ttc&#039; =&gt; &#039;font/collection&#039;, &#039;ttf&#039; =&gt; &#039;font/ttf&#039;, &#039;ttl&#039; =&gt; &#039;text/turtle&#039;, &#039;ttml&#039; =&gt; &#039;application/ttml+xml&#039;, &#039;twd&#039; =&gt; &#039;application/vnd.simtech-mindmapper&#039;, &#039;twds&#039; =&gt; &#039;application/vnd.simtech-mindmapper&#039;, &#039;txd&#039; =&gt; &#039;application/vnd.genomatix.tuxedo&#039;, &#039;txf&#039; =&gt; &#039;application/vnd.mobius.txf&#039;, &#039;txt&#039; =&gt; &#039;text/plain&#039;, &#039;u3d&#039; =&gt; &#039;model/u3d&#039;, &#039;u8dsn&#039; =&gt; &#039;message/global-delivery-status&#039;, &#039;u8hdr&#039; =&gt; &#039;message/global-headers&#039;, &#039;u8mdn&#039; =&gt; &#039;message/global-disposition-notification&#039;, &#039;u8msg&#039; =&gt; &#039;message/global&#039;, &#039;u32&#039; =&gt; &#039;application/x-authorware-bin&#039;, &#039;ubj&#039; =&gt; &#039;application/ubjson&#039;, &#039;udeb&#039; =&gt; &#039;application/x-debian-package&#039;, &#039;ufd&#039; =&gt; &#039;application/vnd.ufdl&#039;, &#039;ufdl&#039; =&gt; &#039;application/vnd.ufdl&#039;, &#039;ulx&#039; =&gt; &#039;application/x-glulx&#039;, &#039;umj&#039; =&gt; &#039;application/vnd.umajin&#039;, &#039;unityweb&#039; =&gt; &#039;application/vnd.unity&#039;, &#039;uoml&#039; =&gt; &#039;application/vnd.uoml+xml&#039;, &#039;uri&#039; =&gt; &#039;text/uri-list&#039;, &#039;uris&#039; =&gt; &#039;text/uri-list&#039;, &#039;urls&#039; =&gt; &#039;text/uri-list&#039;, &#039;usdz&#039; =&gt; &#039;model/vnd.usdz+zip&#039;, &#039;ustar&#039; =&gt; &#039;application/x-ustar&#039;, &#039;utz&#039; =&gt; &#039;application/vnd.uiq.theme&#039;, &#039;uu&#039; =&gt; &#039;text/x-uuencode&#039;, &#039;uva&#039; =&gt; &#039;audio/vnd.dece.audio&#039;, &#039;uvd&#039; =&gt; &#039;application/vnd.dece.data&#039;, &#039;uvf&#039; =&gt; &#039;application/vnd.dece.data&#039;, &#039;uvg&#039; =&gt; &#039;image/vnd.dece.graphic&#039;, &#039;uvh&#039; =&gt; &#039;video/vnd.dece.hd&#039;, &#039;uvi&#039; =&gt; &#039;image/vnd.dece.graphic&#039;, &#039;uvm&#039; =&gt; &#039;video/vnd.dece.mobile&#039;, &#039;uvp&#039; =&gt; &#039;video/vnd.dece.pd&#039;, &#039;uvs&#039; =&gt; &#039;video/vnd.dece.sd&#039;, &#039;uvt&#039; =&gt; &#039;application/vnd.dece.ttml+xml&#039;, &#039;uvu&#039; =&gt; &#039;video/vnd.uvvu.mp4&#039;, &#039;uvv&#039; =&gt; &#039;video/vnd.dece.video&#039;, &#039;uvva&#039; =&gt; &#039;audio/vnd.dece.audio&#039;, &#039;uvvd&#039; =&gt; &#039;application/vnd.dece.data&#039;, &#039;uvvf&#039; =&gt; &#039;application/vnd.dece.data&#039;, &#039;uvvg&#039; =&gt; &#039;image/vnd.dece.graphic&#039;, &#039;uvvh&#039; =&gt; &#039;video/vnd.dece.hd&#039;, &#039;uvvi&#039; =&gt; &#039;image/vnd.dece.graphic&#039;, &#039;uvvm&#039; =&gt; &#039;video/vnd.dece.mobile&#039;, &#039;uvvp&#039; =&gt; &#039;video/vnd.dece.pd&#039;, &#039;uvvs&#039; =&gt; &#039;video/vnd.dece.sd&#039;, &#039;uvvt&#039; =&gt; &#039;application/vnd.dece.ttml+xml&#039;, &#039;uvvu&#039; =&gt; &#039;video/vnd.uvvu.mp4&#039;, &#039;uvvv&#039; =&gt; &#039;video/vnd.dece.video&#039;, &#039;uvvx&#039; =&gt; &#039;application/vnd.dece.unspecified&#039;, &#039;uvvz&#039; =&gt; &#039;application/vnd.dece.zip&#039;, &#039;uvx&#039; =&gt; &#039;application/vnd.dece.unspecified&#039;, &#039;uvz&#039; =&gt; &#039;application/vnd.dece.zip&#039;, &#039;vbox&#039; =&gt; &#039;application/x-virtualbox-vbox&#039;, &#039;vbox-extpack&#039; =&gt; &#039;application/x-virtualbox-vbox-extpack&#039;, &#039;vcard&#039; =&gt; &#039;text/vcard&#039;, &#039;vcd&#039; =&gt; &#039;application/x-cdlink&#039;, &#039;vcf&#039; =&gt; &#039;text/x-vcard&#039;, &#039;vcg&#039; =&gt; &#039;application/vnd.groove-vcard&#039;, &#039;vcs&#039; =&gt; &#039;text/x-vcalendar&#039;, &#039;vcx&#039; =&gt; &#039;application/vnd.vcx&#039;, &#039;vdi&#039; =&gt; &#039;application/x-virtualbox-vdi&#039;, &#039;vds&#039; =&gt; &#039;model/vnd.sap.vds&#039;, &#039;vhd&#039; =&gt; &#039;application/x-virtualbox-vhd&#039;, &#039;vis&#039; =&gt; &#039;application/vnd.visionary&#039;, &#039;viv&#039; =&gt; &#039;video/vnd.vivo&#039;, &#039;vlc&#039; =&gt; &#039;application/videolan&#039;, &#039;vmdk&#039; =&gt; &#039;application/x-virtualbox-vmdk&#039;, &#039;vob&#039; =&gt; &#039;video/x-ms-vob&#039;, &#039;vor&#039; =&gt; &#039;application/vnd.stardivision.writer&#039;, &#039;vox&#039; =&gt; &#039;application/x-authorware-bin&#039;, &#039;vrml&#039; =&gt; &#039;model/vrml&#039;, &#039;vsd&#039; =&gt; &#039;application/vnd.visio&#039;, &#039;vsf&#039; =&gt; &#039;application/vnd.vsf&#039;, &#039;vss&#039; =&gt; &#039;application/vnd.visio&#039;, &#039;vst&#039; =&gt; &#039;application/vnd.visio&#039;, &#039;vsw&#039; =&gt; &#039;application/vnd.visio&#039;, &#039;vtf&#039; =&gt; &#039;image/vnd.valve.source.texture&#039;, &#039;vtt&#039; =&gt; &#039;text/vtt&#039;, &#039;vtu&#039; =&gt; &#039;model/vnd.vtu&#039;, &#039;vxml&#039; =&gt; &#039;application/voicexml+xml&#039;, &#039;w3d&#039; =&gt; &#039;application/x-director&#039;, &#039;wad&#039; =&gt; &#039;application/x-doom&#039;, &#039;wadl&#039; =&gt; &#039;application/vnd.sun.wadl+xml&#039;, &#039;war&#039; =&gt; &#039;application/java-archive&#039;, &#039;wasm&#039; =&gt; &#039;application/wasm&#039;, &#039;wav&#039; =&gt; &#039;audio/x-wav&#039;, &#039;wax&#039; =&gt; &#039;audio/x-ms-wax&#039;, &#039;wbmp&#039; =&gt; &#039;image/vnd.wap.wbmp&#039;, &#039;wbs&#039; =&gt; &#039;application/vnd.criticaltools.wbs+xml&#039;, &#039;wbxml&#039; =&gt; &#039;application/wbxml&#039;, &#039;wcm&#039; =&gt; &#039;application/vnd.ms-works&#039;, &#039;wdb&#039; =&gt; &#039;application/vnd.ms-works&#039;, &#039;wdp&#039; =&gt; &#039;image/vnd.ms-photo&#039;, &#039;weba&#039; =&gt; &#039;audio/webm&#039;, &#039;webapp&#039; =&gt; &#039;application/x-web-app-manifest+json&#039;, &#039;webm&#039; =&gt; &#039;video/webm&#039;, &#039;webmanifest&#039; =&gt; &#039;application/manifest+json&#039;, &#039;webp&#039; =&gt; &#039;image/webp&#039;, &#039;wg&#039; =&gt; &#039;application/vnd.pmi.widget&#039;, &#039;wgt&#039; =&gt; &#039;application/widget&#039;, &#039;wif&#039; =&gt; &#039;application/watcherinfo+xml&#039;, &#039;wks&#039; =&gt; &#039;application/vnd.ms-works&#039;, &#039;wm&#039; =&gt; &#039;video/x-ms-wm&#039;, &#039;wma&#039; =&gt; &#039;audio/x-ms-wma&#039;, &#039;wmd&#039; =&gt; &#039;application/x-ms-wmd&#039;, &#039;wmf&#039; =&gt; &#039;image/wmf&#039;, &#039;wml&#039; =&gt; &#039;text/vnd.wap.wml&#039;, &#039;wmlc&#039; =&gt; &#039;application/wmlc&#039;, &#039;wmls&#039; =&gt; &#039;text/vnd.wap.wmlscript&#039;, &#039;wmlsc&#039; =&gt; &#039;application/vnd.wap.wmlscriptc&#039;, &#039;wmv&#039; =&gt; &#039;video/x-ms-wmv&#039;, &#039;wmx&#039; =&gt; &#039;video/x-ms-wmx&#039;, &#039;wmz&#039; =&gt; &#039;application/x-msmetafile&#039;, &#039;woff&#039; =&gt; &#039;font/woff&#039;, &#039;woff2&#039; =&gt; &#039;font/woff2&#039;, &#039;word&#039; =&gt; &#039;application/msword&#039;, &#039;wpd&#039; =&gt; &#039;application/vnd.wordperfect&#039;, &#039;wpl&#039; =&gt; &#039;application/vnd.ms-wpl&#039;, &#039;wps&#039; =&gt; &#039;application/vnd.ms-works&#039;, &#039;wqd&#039; =&gt; &#039;application/vnd.wqd&#039;, &#039;wri&#039; =&gt; &#039;application/x-mswrite&#039;, &#039;wrl&#039; =&gt; &#039;model/vrml&#039;, &#039;wsc&#039; =&gt; &#039;message/vnd.wfa.wsc&#039;, &#039;wsdl&#039; =&gt; &#039;application/wsdl+xml&#039;, &#039;wspolicy&#039; =&gt; &#039;application/wspolicy+xml&#039;, &#039;wtb&#039; =&gt; &#039;application/vnd.webturbo&#039;, &#039;wvx&#039; =&gt; &#039;video/x-ms-wvx&#039;, &#039;x3d&#039; =&gt; &#039;model/x3d+xml&#039;, &#039;x3db&#039; =&gt; &#039;model/x3d+fastinfoset&#039;, &#039;x3dbz&#039; =&gt; &#039;model/x3d+binary&#039;, &#039;x3dv&#039; =&gt; &#039;model/x3d-vrml&#039;, &#039;x3dvz&#039; =&gt; &#039;model/x3d+vrml&#039;, &#039;x3dz&#039; =&gt; &#039;model/x3d+xml&#039;, &#039;x32&#039; =&gt; &#039;application/x-authorware-bin&#039;, &#039;x_b&#039; =&gt; &#039;model/vnd.parasolid.transmit.binary&#039;, &#039;x_t&#039; =&gt; &#039;model/vnd.parasolid.transmit.text&#039;, &#039;xaml&#039; =&gt; &#039;application/xaml+xml&#039;, &#039;xap&#039; =&gt; &#039;application/x-silverlight-app&#039;, &#039;xar&#039; =&gt; &#039;application/vnd.xara&#039;, &#039;xav&#039; =&gt; &#039;application/xcap-att+xml&#039;, &#039;xbap&#039; =&gt; &#039;application/x-ms-xbap&#039;, &#039;xbd&#039; =&gt; &#039;application/vnd.fujixerox.docuworks.binder&#039;, &#039;xbm&#039; =&gt; &#039;image/x-xbitmap&#039;, &#039;xca&#039; =&gt; &#039;application/xcap-caps+xml&#039;, &#039;xcs&#039; =&gt; &#039;application/calendar+xml&#039;, &#039;xdf&#039; =&gt; &#039;application/xcap-diff+xml&#039;, &#039;xdm&#039; =&gt; &#039;application/vnd.syncml.dm+xml&#039;, &#039;xdp&#039; =&gt; &#039;application/vnd.adobe.xdp+xml&#039;, &#039;xdssc&#039; =&gt; &#039;application/dssc+xml&#039;, &#039;xdw&#039; =&gt; &#039;application/vnd.fujixerox.docuworks&#039;, &#039;xel&#039; =&gt; &#039;application/xcap-el+xml&#039;, &#039;xenc&#039; =&gt; &#039;application/xenc+xml&#039;, &#039;xer&#039; =&gt; &#039;application/patch-ops-error+xml&#039;, &#039;xfdf&#039; =&gt; &#039;application/vnd.adobe.xfdf&#039;, &#039;xfdl&#039; =&gt; &#039;application/vnd.xfdl&#039;, &#039;xht&#039; =&gt; &#039;application/xhtml+xml&#039;, &#039;xhtml&#039; =&gt; &#039;application/xhtml+xml&#039;, &#039;xhvml&#039; =&gt; &#039;application/xv+xml&#039;, &#039;xif&#039; =&gt; &#039;image/vnd.xiff&#039;, &#039;xl&#039; =&gt; &#039;application/excel&#039;, &#039;xla&#039; =&gt; &#039;application/vnd.ms-excel&#039;, &#039;xlam&#039; =&gt; &#039;application/vnd.ms-excel.addin.macroEnabled.12&#039;, &#039;xlc&#039; =&gt; &#039;application/vnd.ms-excel&#039;, &#039;xlf&#039; =&gt; &#039;application/xliff+xml&#039;, &#039;xlm&#039; =&gt; &#039;application/vnd.ms-excel&#039;, &#039;xls&#039; =&gt; &#039;application/vnd.ms-excel&#039;, &#039;xlsb&#039; =&gt; &#039;application/vnd.ms-excel.sheet.binary.macroEnabled.12&#039;, &#039;xlsm&#039; =&gt; &#039;application/vnd.ms-excel.sheet.macroEnabled.12&#039;, &#039;xlsx&#039; =&gt; &#039;application/vnd.openxmlformats-officedocument.spreadsheetml.sheet&#039;, &#039;xlt&#039; =&gt; &#039;application/vnd.ms-excel&#039;, &#039;xltm&#039; =&gt; &#039;application/vnd.ms-excel.template.macroEnabled.12&#039;, &#039;xltx&#039; =&gt; &#039;application/vnd.openxmlformats-officedocument.spreadsheetml.template&#039;, &#039;xlw&#039; =&gt; &#039;application/vnd.ms-excel&#039;, &#039;xm&#039; =&gt; &#039;audio/xm&#039;, &#039;xml&#039; =&gt; &#039;application/xml&#039;, &#039;xns&#039; =&gt; &#039;application/xcap-ns+xml&#039;, &#039;xo&#039; =&gt; &#039;application/vnd.olpc-sugar&#039;, &#039;xop&#039; =&gt; &#039;application/xop+xml&#039;, &#039;xpi&#039; =&gt; &#039;application/x-xpinstall&#039;, &#039;xpl&#039; =&gt; &#039;application/xproc+xml&#039;, &#039;xpm&#039; =&gt; &#039;image/x-xpixmap&#039;, &#039;xpr&#039; =&gt; &#039;application/vnd.is-xpr&#039;, &#039;xps&#039; =&gt; &#039;application/vnd.ms-xpsdocument&#039;, &#039;xpw&#039; =&gt; &#039;application/vnd.intercon.formnet&#039;, &#039;xpx&#039; =&gt; &#039;application/vnd.intercon.formnet&#039;, &#039;xsd&#039; =&gt; &#039;application/xml&#039;, &#039;xsl&#039; =&gt; &#039;application/xml&#039;, &#039;xslt&#039; =&gt; &#039;application/xslt+xml&#039;, &#039;xsm&#039; =&gt; &#039;application/vnd.syncml+xml&#039;, &#039;xspf&#039; =&gt; &#039;application/xspf+xml&#039;, &#039;xul&#039; =&gt; &#039;application/vnd.mozilla.xul+xml&#039;, &#039;xvm&#039; =&gt; &#039;application/xv+xml&#039;, &#039;xvml&#039; =&gt; &#039;application/xv+xml&#039;, &#039;xwd&#039; =&gt; &#039;image/x-xwindowdump&#039;, &#039;xyz&#039; =&gt; &#039;chemical/x-xyz&#039;, &#039;xz&#039; =&gt; &#039;application/x-xz&#039;, &#039;yaml&#039; =&gt; &#039;text/yaml&#039;, &#039;yang&#039; =&gt; &#039;application/yang&#039;, &#039;yin&#039; =&gt; &#039;application/yin+xml&#039;, &#039;yml&#039; =&gt; &#039;text/yaml&#039;, &#039;ymp&#039; =&gt; &#039;text/x-suse-ymp&#039;, &#039;z&#039; =&gt; &#039;application/x-compress&#039;, &#039;z1&#039; =&gt; &#039;application/x-zmachine&#039;, &#039;z2&#039; =&gt; &#039;application/x-zmachine&#039;, &#039;z3&#039; =&gt; &#039;application/x-zmachine&#039;, &#039;z4&#039; =&gt; &#039;application/x-zmachine&#039;, &#039;z5&#039; =&gt; &#039;application/x-zmachine&#039;, &#039;z6&#039; =&gt; &#039;application/x-zmachine&#039;, &#039;z7&#039; =&gt; &#039;application/x-zmachine&#039;, &#039;z8&#039; =&gt; &#039;application/x-zmachine&#039;, &#039;zaz&#039; =&gt; &#039;application/vnd.zzazz.deck+xml&#039;, &#039;zip&#039; =&gt; &#039;application/zip&#039;, &#039;zir&#039; =&gt; &#039;application/vnd.zul&#039;, &#039;zirz&#039; =&gt; &#039;application/vnd.zul&#039;, &#039;zmm&#039; =&gt; &#039;application/vnd.handheld-entertainment+xml&#039;, &#039;zsh&#039; =&gt; &#039;text/x-scriptzsh&#039;]|


## Methods


### fromFilename

Determines the mimetype of a file by looking at its extension.

```php
public static fromFilename(string $filename): ?string
```



* This method is **static**.




**Parameters:**

| Parameter | Type | Description |
|-----------|------|-------------|
| `$filename` | **string** |  |



**See Also:**

* https://raw.githubusercontent.com/jshttp/mime-db/master/db.json - 

***

### fromExtension

Maps a file extensions to a mimetype.

```php
public static fromExtension(string $extension): ?string
```



* This method is **static**.




**Parameters:**

| Parameter | Type | Description |
|-----------|------|-------------|
| `$extension` | **string** |  |



**See Also:**

* https://raw.githubusercontent.com/jshttp/mime-db/master/db.json - 

***


***

